/*            Universidad Autonoma de Puebla
      Departamento de Aplicacion de Microcomputadoras

           Genera una superficie o un contorno del
 	   del valor absoluto o de la fase de  una
           funcion compleja.
      J.P.H.E.
*/

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "plotp.h"
#include "ac.h"

#define  NX 51
#define  NY 51

struct complex aclog( struct complex nc)
{
   struct complex r;
   r.x = log(acabs(nc));
   r.y = acarc(nc);
   return r;
}

double  WY[NX][NY], WA[NX][NY];

main()
{
  int     i, j, nci;
  double  x, y, xmi, xma, ymi, yma;
  double  z, w, zmi, zma, zi, za, dx, dy;
  struct  complex cx, cy, cw, uno;
  char    suco, moin;
  xmi     = -1.7;       xma = 2.0;
  ymi     = -1.2;       yma = 1.2;


  for(;;) {
    printf("\n       exp(1/z)\n\n");
    printf("\n Intervalo en X %lf, %lf\n Intervalo en Y %lf, %lf",xmi,xma,ymi,yma);
    moin = 'E';
    while(!(moin=='S' || moin=='N')) {
	  printf("\n\n Modificar los intervalos? (S/N) ");
	  scanf("%c", &moin); moin = (islower(moin)) ? _toupper(moin) : moin;
	  i=getchar();
    }
    if(moin=='S') {
       printf("\n Valor Minimo en X = ");  scanf("%lf", &xmi);
       printf(" Valor Maximo en X = ");    scanf("%lf", &xma);
       printf(" Valor Minimo en Y = ");    scanf("%lf", &ymi);
       printf(" Valor Maximo en Y = ");    scanf("%lf", &yma);
       i = getchar();                   /* Para anular ENTER */
    }
    dx   = fabs(xma-xmi)/(double) (NX-1);
    dy   = fabs(yma-ymi)/(double) (NY-1);

    uno  = cmplx(1.0, 0.0);
    cw   = acdiv(uno, cmplx(xmi, ymi));
    cx   = acexp(cw);
    zmi  = cabs(cx);
    zi   = acarc(cx);
    zma  = zmi;
    za   = zi;
    x    = xmi;
    for(i=0; i < NX; i++) {
	y = ymi;
	for(j=0; j < NY; j++) {
	    cx = cmplx(x, y);
	    cw = acexp(acdiv(uno, cx));
	    z  = cabs(cw);
	    w  = acarc(cw);
	    if( z >= 6.0 ) z = 6.0;
	    WY[i][j] = (double) z;
	    WA[i][j] = (double) w;
	    zmi = (zmi > z) ? z   : zmi;
	    zma = (zma > z) ? zma : z;
	    zi  = (zi  > w) ? w   : zi;
	    za  = (za  > w) ? za  : w;
	    y  += dy;
	}
	x += dx;
    }
    x   = fabs(zma-zmi)/10.0;
    y   = fabs(za - zi)/10.0;
    zmi = zmi - x;     zma = zma + x;
    zi  = zi  - y;     za  = za  + y;

    plt00();
    plotf(-1);
    plotz("V1 ",3);                   /* DMP-29  */
    pltfr(1);

    plot(2.5,  -0.25, UP);                           /* Marco Izquierdo */
    plot(2.5,  -5.25, DOWN);
    plot(-2.5, -5.25, DOWN);
    plot(-2.5, -0.25, DOWN);
    plot(2.5,  -0.25, DOWN);
    plot(2.5,   0.25, UP);                             /* Marco Derecho */
    plot(-2.5,  0.25, DOWN);
    plot(-2.5,  5.25, DOWN);
    plot(2.5,   5.25, DOWN);
    plot(2.5,   0.25, DOWN);

    pltso(2.4, 2.4, 0.0,  2.75);       /* Contornos de valor absoluto */
    pltcolor(3); plotz("P2 ",3);                       /* Color negro */
    pltkp(zmi, &WY[0][0], zma, 20, NX/64+1, NX, NY/64+1, NY, pltca);
    pltig(xmi, ymi, 1, pltca);
    pltig(xma, yma, 2, pltca);
    pltig(0.0, 0.0, 9, pltca);

    pltcolor(2);              plotz("P3 ",3);         /* Color verde */
    pltkc(zi,  &WA[0][0], za,  20, 2, NX, 2, NY, pltca);
    plotr();

    plotz("P2 ",3);                                      /* Color negro */
    pltso(2.4, 2.4, 0.0, -2.75);           /* Superficie del valor abs. */
    for(i = 0; i < NX; i++) WY[i][0] = 0.0;
    for(i = 0; i < NY; i++) WY[0][i] = 0.0;
    x = xmi;
    for(i=0; i < NX; i++) {
	y = ymi;
	for(j=0; j < NY; j++) {
	    if(x < 0.0 && y < 0.0) WY[i][j] = 0.0;
	     y += dy;
	}
	x += dx;
    }
    pltrv(zmi, &WY[0][0], zma, NX, NY, 15.0, pltca);

    plotr();
    plotz("P4 ",3);
    pltlla("w = exp(1/z), z = x + iy", 24,
 "Superficie del valor absoluto                      Contornos de fase     ",
	     80, 1);
    pltho();
    pltclose();
 }
}
