/*             UNIVERSIDAD AUTONOMA DE PUEBLA
       DEPARTAMENTO DE APLICACION DE MICROCOMPUTADORAS
Superficie y contornos de w=z*z+c, z=a+bi (PLTRV, PLTKP y PLKC)
	          [J.P.H.E.    JUL-1993]
*/
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "plotp.h"
#include "ac.h"

#define  NX   37            /* Dimension de las matrices de valores */
#define  NY   37            /* para el contorno o la superficie     */
double   WY[NX][NY], WA[NX][NY];


main()
{
  int     i, j, nci;
  double  x, y, xmi, xma, ymi, yma;
  double  z, w, zmi, zma, zi, za, dx, dy;
  struct  complex cx, cy, cw;
  char    bu[] ={"Superficie y contornos de w=z*z+c, z=a+bi"};
  char    bin[60], moin;

  xmi     = -3.0;       xma = 3.0;    /* Dominio de la funcion compleja */
  ymi     = -3.0;       yma = 3.0;


  for(;;) {
     printf("\n         z = z*z + c\n\n");

    printf("\n Intervalo en X %lf, %lf\n Intervalo en Y %lf, %lf",xmi,xma,ymi,yma);
    moin = 'E';
    while(!(moin=='S' || moin=='N')) {
	  printf("\n\n Modificar los intervalos? (S/N) ");
	  scanf("%c", &moin); moin = (islower(moin)) ? _toupper(moin) : moin;
	  i=getchar();                                    /* Anula Enter */
    }
    if(moin=='S') {
       printf("\n Valor Minimo en X = ");        scanf("%lf", &xmi);
       printf(" Valor Maximo en X = ");          scanf("%lf", &xma);
       printf(" Valor Minimo en Y = ");          scanf("%lf", &ymi);
       printf(" Valor Maximo en Y = ");          scanf("%lf", &yma);
       i = getchar();			                  /* Anular ENTER */
    }
    dx   = fabs(xma-xmi)/(double) (NX-1);
    dy   = fabs(yma-ymi)/(double) (NY-1);

    cy   = cmplx(1.0, 2.0);
    cw   = cmplx(xmi, ymi);
    cx   = acsum(acmul(cw, cw), cy);                       /* Funcion */
    zmi  = cabs(cx);
    zi   = acarc(cx);
    zma  = zmi;
    za   = zi;
    x    = xmi;
    for(i=0; i < NY; i++) {
	y = xmi;
	for(j=0; j < NX; j++) {
	    cx = cmplx(x, y);
	    cw = acsum(acmul(cx, cx), cy);                     /* Funcion */
	    z  = cabs(cw);                              /* Valor absoluto */
	    w  = acarc(cw);                             /* Fase           */
	    WY[i][j] = (double) z;
	    WA[i][j] = (double) w;
	    zmi = (zmi > z) ? z   : zmi; /* Calculo del valor min. y max. */
	    zma = (zma > z) ? zma : z;
	    zi  = (zi  > w) ? w   : zi;
	    za  = (za  > w) ? za  : w;
	    y  += dy;
	}
	x += dx;
    }
    x   = fabs(zma-zmi)/8.0;           /*  Ajuste del valor min. y max. */
    y   = fabs(za - zi)/8.0;
    zmi = zmi;         zma = zma - 5.0*x;
    zi  = zi  - y;     za  = za  - 5.0*y;

    plt00();
    plotz("V1 ",3);                                           /* DMP-29  */
    pltfr(1);
    plot( 2.0,  0.5,  UP);                            /* Marco superior */
    plot(-2.0, 0.5, DOWN);    plot(-2.0, 4.5, DOWN);
    plot( 2.0, 4.5, DOWN);    plot( 2.0, 0.5, DOWN);

    plot( 2.0, -0.5,  UP);                            /* Marco inferior */
    plot( 2.0, -4.5, DOWN);    plot(-2.0, -4.5, DOWN);
    plot(-2.0, -0.5, DOWN);    plot( 2.0, -0.5, DOWN);

    pltso(1.95, 1.90, 0.0, 2.5);
    pltcolor(7);
    pltrv(zmi, &WY[0][0], zma, NX, NY, -1.0, pltca);
    plotr();

    pltso(1.95, 1.95, 0.0, -2.5);
    pltcolor(2);
    pltkp(zmi, &WY[0][0], zma, 20, 2, NX, 2, NY, pltca);
    plotz("P2 ",3);
    pltcolor(7);
    pltkc(zi,  &WA[0][0], za,  20, 2, NX, 2, NY, pltca);
    plotr();
    pltcolor(2);                         plotz("P1 ",3);
    nci = pltgi(bin, xmi, 'X', xma, ymi, 'I', yma);
    pltlla(bu, sizeof(bu)-1, bin, nci, 1);

    pltho();
    pltclose();
 }
}