#include <math.h>

#include "plotp.h"

#define  NT  29
#define  NP  90


/*

     (dem19c)
     DEMOSTRACION plot84.
     25.jun.93
*/

static double O1[3][3];


  void d19sp( PH, TH, P)
  double PH,TH;
  int    P;
  {
    double the,phi,x,y,z,u,v,w,ro,fi;


   the = 3.14159 * TH;
   phi = 6.28318 * PH;
   x   = sin(the) * cos(phi);
   y   = sin(the) * sin(phi);
   z   = cos(the);
   u   = O1[0][0]*x + O1[0][1]*y + O1[0][2]*z;
   v   = O1[1][0]*x + O1[1][1]*y + O1[1][2]*z;
   w   = O1[2][0]*x + O1[2][1]*y + O1[2][2]*z;
   ro  = sqrt(u*u+v*v);
   fi  = atan2(v,u)/6.28318;
   pltpo(fi, ro, (int)(P && (w >= 0.0)) );

   }

   double EF[NP][NT];

void main(void)
{
   int l,i,j;
   double s,dt,dp,t,p,tf,pf,ra;

  l = 1;
  s = -1.0;

  plteu(&O1[0][0], 10.0, -60.0, 10.0);

  dt = 3.14159 / (double)(NT-1);
  dp = 6.28318 / (double)(NP);
  t  = 3.14159;

  for(i = 0 ; i < NT ; i++)
  {
    p  = 0.475;
    for (j = 0 ; j < NP ; j++)
    {
      tf = 0.67 * (1.0 + 0.5*cos(3.0*t) + s*0.1667*cos(9.0*t) );
      pf = 0.67 * (1.0 + 0.5*sin(3.0*p) - s*0.1667*sin(9.0*p) );
      ra = tf*pf;
      switch (l) {
       case 1: EF[j][i] = ra;
       case 2: EF[j][i] = fsgn( sin(6.0*t)*sin(12.0*p) ) * fabs(ra) ;
       case 3: EF[j][i] = fsgn( sin(31.4*ra) ) * fabs(ra) ;
      };
      p += dp;
     };
     t -= dt;
  };

  plt00();
  pltfr(5);
  pltso( 3.00, 3.00, 0.00, 0.00);
  plotf(-1);

  pltkx (0.50, &EF[0][0], 1.0, NP, NT, d19sp);
  pltky (0.80, &EF[0][0], 1.0, NP, NT, d19sp);
  pltkp (0.0 , &EF[0][0], 1.0, 40, 6, NP, 3, NT, d19sp);

  pltla("[pltkp]",7);

  pltho();
  pltclose();
}
