/*           UNIVERSIDAD AUTONOMA DE PUEBLA
    DEPARTAMENTO DE APLICACION DE MICROCOMPUATADORAS
    AMILCAR MENESES VIVEROS
*/

#include "stdio.h"
#include "math.h"
#include "plotp.h"

#define         NP      120             /* Vertices del diagrama */
#define         MP      1.5708          /* PI / 2                */
#define         CB      5               /* Cte. Diag. de Bruijn  */
#define         R1      2.45            /* Radio 1               */
#define         R2      2.5             /* Radio 2               */
#define         ND      3               /* Num. de diagramas     */
#define         COLOR   2               /* Color                 */

int pltdbr(double thi, double dt)
{
  double th1, th2;
  double x,y;
  int ciclo, i, j;

  ciclo = NP/2;
  for(i=0, th1=thi; i<ciclo; i++, th1+=dt)
  {
    x = R1*cos(th1);
    y = R1*sin(th1);
    plot(x,y,0);

    for (j = 1; j<5; j++)
    {
      switch(j) {
      case 1: th2 = thi + ((double)(i*2 +1 ))*dt;
	      x = R2*cos(th2);
	      y = R2*sin(th2);
	      break;
      case 2: th2 = thi + ((double)(i+ciclo))*dt;
	      x = R1*cos(th2);
	      y = R1*sin(th2);
	      break;
      case 3: th2 = thi + ((double)((i*2)))*dt;
	      x = R2*cos(th2);
	      y = R2*sin(th2);
	      break;
      case 4: x = R1*cos(th1);
	      y = R1*sin(th1);
	      break;
      default: printf("Error !"); break;
      }
      plot(x,y,1);
    }
   }
}

int pltcir(double R, double thi, double dt)
{
  double th;                            /* Angulo theta */
  int i;                                /* Subindice    */

  plot(R*cos(thi), 0.0, 0);
  for (i=0, th=thi; i< (NP+1); i++, th+=dt)
    plot(R*cos(th), R*sin(th), 1);

}


main()
{
  double dt;                            /* Incremento en theta  */
  double thi;                           /* theta inicial        */
  double phi;                           /* Angulo PHI           */
  double dph;                           /* Incremento en phi    */
  int    i;                             /* Contador de Diagramas*/
  int    color = COLOR;                 /* Color Base           */

  dt  = 6.2831 / (double)(NP);
  thi = dt / 2.0;
  dph = 6.2831 / (double)(ND);
  phi = thi;

  plt00();
  pltfr(6);
  pltcir(R1, thi, dt);                  /* Traza circulo de Radio R1 */
  pltcir(R2, thi, dt);                  /* Traza circulo de Radio R2 */

  for (i = 0; i<ND; i++)
  {
   pltcolor(color++);
   pltdbr(phi, dt);                     /* Traza Digrama de Bruijn   */
   phi += dph;
  }
  pltcolor(COLOR);
  pltho();
  pltclose();
}
