#include <stdio.h>
#include <math.h>
#include <string.h>
#include "plotp.h"


#define OX 3.0   /* Origen */
#define OY -4.0
#define EX -5.5 /* Escalas en X y Y */
#define EY 8.0
#define px 10

/*
   barras.c

   Grafica de barras de datos en dos dimensiones
   Los datos son tomados de un archivo de entrada.
   el archivo tiene las sig. caracteristicas:
   - letrero principal.
   - numero total de datos.
   - datos   letrero

   Angel B. Canto Gomez. Febrero 1995.
*/

void main(void)
{

  char name[20],titulo[80],elem[15];
  FILE *arch;
  int tam,i,py;
  int leecadena();
  float valor;
  double aval[100],max,min,dx,dy,lfu,dfu,dnu,aux,aux1;

/* Lee nombre del archivo de entrada. */
  printf("\n Archivo de entrada: ");
  scanf("%s", name);
  if((arch = fopen(name,"r")) == NULL)
  {  printf("\n Error en el archivo de entrada: %s \n\n",name);
    exit(0);
  };
  getchar();

/* Lee titulo de la grafica del archivo. */
  tam = leecadena(arch, &titulo[0]);

  if(tam > 60)
  { printf("\n Titulo Mayor de 60 caracteres: ");
    printf("\n %s",titulo);
    exit(0);
  };

/* Lee el numero de datos de la grafica. */
  fscanf(arch,"%d",&py);
  if(py < 1)
  { printf("\n !!! Contiene menos de un valor el archivo. \n\n");
    exit(1);
  };

  i = plt00();
  if (i==1)  plotz("V1",2);  /* Velocidad reducida en graficador HIPLOT */

  pltfr(1);
/* Coloca el Titulo en la grafica. */
 plttp(-3.5, -(0.08666*tam), 0.17, &titulo[0], 90.0, tam,1,pltmv);

  plot(OX, OY, UP); /* Define Origen */
  ploto();

  plot(0.0, 0.0, UP); /* Traza Eje X */
  plot(0.0, EY, DOWN);
  plot(EX-0.07, 0.0, UP);
  plot(EX-0.07,EY,DOWN);


  fscanf(arch,"%s",elem);

 /* Lee el primer valor del archivo de datos. */
  fscanf(arch,"%f",&valor);
  max = min = aval[0]= valor;

  dy = EY/(double)(py);

  for(dx=dy, i=1 ; i < py; i++, dx+=dy) {
   plttp(0.2, (dx-dy+0.05), 0.06, &elem[0], 90.0, (int)(strlen(elem)),1,pltmv);
   plot(0.0, dx, UP);
   plot( 0.1, dx, DOWN);
   fscanf(arch,"%s",elem);
   fscanf(arch,"%f", &valor);
   aval[i] = valor;
   if (aval[i] > max) max = aval[i];
   if (aval[i] < min) min = aval[i];
  };
   plttp(0.2, (dx-dy+0.05), 0.06, &elem[0], 90.0, (int)(strlen(elem)),1,pltmv);

  plot(0.0, 0.0, UP); /* Traza Eje Y */
  plot(EX-0.07, 0.0, DOWN);
  plot(0.0,EY,UP);
  plot(EX-0.07,EY,DOWN);

  dx = EX/(double)(px);
  lfu = (min < 0) ? (max - min) : max;
  dfu = (min < 0) ? (lfu / (px-1)) : lfu / px;
  dnu = (min < 0) ? (EX /(lfu+dfu)) : EX/lfu;
  lfu = (min < 0) ? min - dfu: 0.0;

  for (i=0, dy=0 ; i < (px+1) ; i++, dy +=dx, lfu +=dfu)
  {
    number(dy, -0.5, 0.06, lfu, 90.0, 1);
    plot( dy, 0.0, UP);
    plot( dy, -0.1, DOWN);
  };

  dy = EY/(double)(py);

  for(i=0,dx=dy; i<py ; i++,dx+=dy)
  {
    aux1 = (min<0) ? (dfu-min)*dnu : 0.0;
/*    plot(aux1-0.05, dx-dy, UP);
    plot(aux1-0.05,dx,DOWN); */

    plot(aux1,dx-0.07,UP);
    aux=(min<0) ? ((aval[i]+dfu-min)*dnu) : (aval[i]*dnu);
    plot(aux, dx-0.07, DOWN);

    plot(aux, dx-dy+0.07, DOWN);
    plot(aux1, dx-dy+0.07,DOWN);

  };

  if (min < 0.0)
  {
    aux = (dfu-min)*dnu;
    plot(aux,0.0,UP);
    plot(aux,EY+0.1,DOWN);
    number(aux, EY+0.2,0.06, 0.0, 90.0, 1);
  }

/*   Video2pcxl("imgplot.pcx"); */

  pltho();
  closeplt();
}


/* leecadena.
   Funcion que se encarga de leer del archivo el titulo de la grafica,
   asi como tambien de contar su longitud en caracteres.
*/

int leecadena(FILE *ip,char *cad)
{
  char c;
  int i=0;

  do{
	 if((c = getc(ip)) == '"'){
	    while((c = getc(ip)) != '"'){
	      if (c == EOF) break;
	      *cad = c;
	      ++cad; ++i;
	    }
	 };

   } while((c != EOF) && (c!='"'));

   *cad = '\0';
   return(i);
}
