#include <stdio.h>
#include <math.h>
#include <string.h>


#include "plotp.h"

char *Video2pcxl(char *fname);
char *farptr(char *p,long l);	/* regresa un apuntador far p+l */
unsigned int pixels2bytes(unsigned int n);
PackPcxFile(char *p, FILE *fp, int bytes);
WritePcxLine( char *p, FILE *fp, int bytes);

#define OX 3.0   /* Origen */
#define OY -4.0
#define EX -5.5 /* Escalas en X y Y */
#define EY 8.0
#define px 10

/*
   barras.c

   Grafica de barras de datos en dos dimensiones
   Los datos son tomados de un archivo de entrada.
   el archivo tiene las sig. caracteristicas:
   - numero total de datos.
   - datos.

   Angel B. Canto Gomez. Enero 1995.
*/

void main()
{

  char name[20],titulo[80],elem[15];
  FILE *arch;
  int tam,i,py;
  int leecadena();
  float valor;
  double aval[100],max,min,dx,dy,lfu,dfu,dnu,aux,aux1;

  printf("\n Archivo de entrada: ");
  scanf("%s", name);
  if((arch = fopen(name,"r")) == NULL)
  {  printf("\n Error en el archivo de entrada: %s \n\n",name);
    exit(0);
  };
  getchar();

/* Lee titulo de la grafica del archivo. */
  tam = leecadena(arch, &titulo[0]);

  if(tam > 60)
  { printf("\n Titulo Mayor de 60 caracteres: ");
    printf("\n %s",titulo);
    exit(0);
  };

/* Lee el numero de datos de la grafica. */
  fscanf(arch,"%d",&py);
  if(py < 1)
  { printf("\n !!! Contiene menos de un valor el archivo. \n\n");
    exit(1);
  };

  plt00(); /* Inicializa. */

 /*  plotz("V1",2);  Velocidad reducida en graficador HIPLOT */

  pltcolor(7);

  pltfr(1);
/* Coloca el Titulo en la grafica. */
 plttp(-3.5, -(0.08666*tam), 0.17, &titulo[0], 90.0, tam,1,pltmv);

  plot(OX, OY, UP); /* Define Origen */
  ploto();

  plot(0.0, 0.0, UP); /* Traza Eje X */
  plot(0.0, EY, DOWN);
  plot(EX-0.07, 0.0, UP);
  plot(EX-0.07,EY,DOWN);


  fscanf(arch,"%s",elem);
  fscanf(arch,"%f",&valor);
  max = min = aval[0]= valor;

  dy = EY/(double)(py);

  for(dx=dy, i=1 ; i < py; i++, dx+=dy) {
   plttp(0.2, (dx-dy+0.05), 0.06, &elem[0], 90.0, (int)(strlen(elem)),1,pltmv);
   plot(0.0, dx, UP);
   plot( 0.1, dx, DOWN);
   fscanf(arch,"%s",elem);
   fscanf(arch,"%f", &valor);
   aval[i] = valor;
   if (aval[i] > max) max = aval[i];
   if (aval[i] < min) min = aval[i];
  };
   plttp(0.2, (dx-dy+0.05), 0.06, &elem[0], 90.0, (int)(strlen(elem)),1,pltmv);

  plot(0.0, 0.0, UP); /* Traza Eje Y */
  plot(EX-0.07, 0.0, DOWN);
  plot(0.0,EY,UP);
  plot(EX-0.07,EY,DOWN);

  dx = EX/(double)(px);
  lfu = (min < 0) ? (max - min) : max;
  dfu = (min < 0) ? (lfu / (px-1)) : lfu / px;
  dnu = (min < 0) ? (EX /(lfu+dfu)) : EX/lfu;
  lfu = (min < 0) ? min - dfu: 0.0;

  for (i=0, dy=0 ; i < (px+1) ; i++, dy +=dx, lfu +=dfu)
  {
    number(dy, -0.5, 0.06, lfu, 90.0, 1);
    plot( dy, 0.0, UP);
    plot( dy, -0.1, DOWN);
  };

  dy = EY/(double)(py);

  for(i=0,dx=dy; i<py ; i++,dx+=dy)
  {
    aux1 = (min<0) ? (dfu-min)*dnu : 0.0;
/*    plot(aux1-0.05, dx-dy, UP);
    plot(aux1-0.05,dx,DOWN); */

    plot(aux1,dx-0.07,UP);
    aux=(min<0) ? ((aval[i]+dfu-min)*dnu) : (aval[i]*dnu);
    plot(aux, dx-0.07, DOWN);

    plot(aux, dx-dy+0.07, DOWN);
    plot(aux1, dx-dy+0.07,DOWN);

  };

  if (min < 0.0)
  {
    aux = (dfu-min)*dnu;
    plot(aux,0.0,UP);
    plot(aux,EY+0.1,DOWN);
    number(aux, EY+0.2,0.06, 0.0, 90.0, 1);
  }

  Video2pcxl("imgplot.pcx");
  pltho();
  closeplt();
}


/* leecadena.
   Funcion que se encarga de leer del archivo el titulo de la grafica,
   asi como tambien de contar su longitud en caracteres.
*/

int leecadena(FILE *ip,char *cad)
{
  char c;
  int i=0;

  do{
	 if((c = getc(ip)) == '"'){
	    while((c = getc(ip)) != '"'){
	      if (c == EOF) break;
	      *cad = c;
	      ++cad; ++i;
	    }
	 };

   } while((c != EOF) && (c!='"'));

   *cad = '\0';
   return(i);
}


/* Funciones para codificar imagenes Monocromaticas BIN	*/
/* al formato PCX, version para imagenes grandes (+64k)	*/
/* Version para el modelo de memoria Large.		*/
/* Bit Mapped Graphics					*/
/* Steve Rimmer.					*/
/* Ed. Windcrest.                                       */
/* Modif. Saturnino Julio De La Trinidad H.		*/
/*		6/FEB/1995				*/

#include "stdio.h"
#include "alloc.h"
#include "dos.h"
#include "pcxhead.h"

PCXHEAD	header;		/* Donde se guarda el encabezado. */

char DefaPallete[]={	/* Paleta por defecto con porcentajes RGB.	*/
     0,   0,   0,     0,  0, 0xaa,     0,0xaa,   0,     0,0xaa,0xaa,
  0xaa,   0,   0,  0xaa,  0, 0xaa,  0xaa,0xaa,   0,  0xaa,0xaa,0xaa,
  0x55,0x55,0x55,  0x55,0x55,0xff,  0x55,0xff,0x55,  0x55,0xff,0xff,
  0xff,0x55,0x55,  0xff,0x55,0xff,  0xff,0xff,0x55,  0xff,0xff,0xff
  };

unsigned int wide, deep;	/* Ancho y profundidad de la imagen.	*/

int bytes=80;			/* Bytes necesarios para una linea.	*/
int MaxX=640, MaxY=480;		/* Resolucion del dispositivo en pixels.*/
int Mode=6;			/* Modo de video actual.		*/


/* Toma la imagen del area de video y la almacena en el formato PCX.	*/
char *Video2pcxl(char *fname)
{
  FILE	*fp;
  char	*p;

  /* Intentamos Abrir el archivo destino. */
  if((fp=fopen(fname,"wb")) !=NULL) {
			/* Apartamos un buffer. */
			wide = MaxX;	/* Pantalla completa.	*/
			deep = MaxY;
			bytes = pixels2bytes(wide);

			if(Mode<5)
			  p=(char *)MK_FP( 0xB800, 0);
			  else
			  p=(char *)MK_FP( 0xA000, 0);

			PackPcxFile(p,fp,bytes);
			fclose( fp );

	}else printf("Error de apertura en: %s.\n", fname);
}


PackPcxFile(char *p, FILE *fp, int bytes) {
  int i, n;

  /* Escribe el encabezado */
  WritePcxHeader( fp );

  /* Empaqueta las lineas. */
  for(i=0; i<deep; i++) {
     n = WritePcxLine(p, fp, bytes);
     p = farptr( p, (long) bytes);	/* p = p+bytes	*/
     }
  return(n);
}


WritePcxLine( char *p, FILE *fp, int bytes)
{
   unsigned int i=0, j=0, t=0;

   do {
	i=0;
	while( (p[t+i] == p[t+i+1] ) && ((t+i) < bytes) && (i<63))
	   i++;
	if(i>0) {
	   fputc( i | 0xC0, fp);
	   fputc( ~p[t], fp); 	/* ~ */
	   t+=i;
	   j+=2;
	   }else{
	   if( ((~p[t]) & 0xC0)==0xC0 ) { /* Caso Critico ~byte=clave. */
	      fputc(0xC1, fp);
	      ++j;
	      }
	   fputc( ~p[t++], fp);	/* ~ */
	   ++j;
	   }
	} while( t<bytes );
   return(j);
}




/* Escribe el encabezado al archivo PCX. */
WritePcxHeader( FILE *fp )
{
  memset((char *)&header, 0, sizeof(PCXHEAD));	/* Limpia bufer con 0's */
  header.manufacturer=0x0A;
  header.version=3;
  header.encoding=1;

  /* Bits per pixel:	1 para monocromatico
			4 para 16 colores ( Posiblemente EGA o VGA )
			8 para 256 colores ( Super VGA ) */

  header.bits_per_pixel=1;
  header.xmin=header.ymin=0;	/* Definen las dimensiones de la imagen	*/
  header.xmax=wide-1;		/* en el archivo en cuestion.		*/
  header.ymax=deep-1;
  header.hres= MaxX;	/* Resolucion del dispositivo que creo la imagen. */
  header.vres= MaxY;
  FillPalette( &header.palette );	/* Coloca la paletta por default. */
  header.colour_planes=1;
  header.bytes_per_line=bytes;
  header.palette_type=2;	/* 1 escala de gris, 2 color completo.	*/

  return( fwrite( (char *)&header, 1, sizeof(PCXHEAD), fp));
}

FillPalette( char s[] )
{
 int i;

 for( i=0; i<48; ++i)
   s[i] = DefaPallete[i];
 }

unsigned int pixels2bytes(unsigned int n)
{
  if(n & 0x0007) return( (n>>3)+1 );
    else  return( n>>3 );
}

char *farptr(char *p,long l)	/* regresa un apuntador far p+l */
{
  unsigned int seg, off;

  seg = FP_SEG( p );
  off = FP_OFF( p );
  seg += (off / 16);
  off &= 0x000f;
  off += (unsigned int) (l & 0x000fL);
  seg += (l / 16L);
  p =  MK_FP(seg, off);
  return( p );
}


/* END */