#include <stdio.h>
#include <math.h>
#include <string.h>

#include "plotp.h"

#define EX -5.5 /* Escalas en X y Y */
#define EY 8.0
#define NP 100
#define ORXC 0.0
#define ORYC 0.0
#define RAD 2.0  /* Radio de la circunferencia. */

/*
   cake.c

   Grafica de porcentajes tomados de una archivo de datos.
   el archivo tiene las sig. caracteristicas:
   - Titulo de la grafica.
   - numero total de datos.
   - datos.
   - etiquetas.

   Angel B. Canto Gomez. Febrero 1995.
*/

void main(void)
{

  char name[20],titulo[80],porct[7],cad[20];
  FILE *arch;
  int tam,i,py;
  int leecadena(),pegada();
  float valor;
  double aval[100],total=0.0,dt,th,fact,sum,cx,cy,facpc,totpc,poslet;

  printf("\n Archivo de entrada: ");
  scanf("%s", name);
  if((arch = fopen(name,"r")) == NULL)
  {  printf("\n Error en el archivo de entrada: %s \n\n",name);
    exit(0);
  };
  getchar();

/* Lee titulo de la grafica del archivo. */
  tam = leecadena(arch, &titulo[0]);

  if(tam > 60)
  { printf("\n Titulo Mayor de 60 caracteres: ");
    printf("\n %s",titulo);
    exit(0);
  };

/* Lee el numero de datos de la grafica. */
  fscanf(arch,"%d",&py);
  if(py < 1)
  { printf("\n !!! Contiene menos de un valor el archivo. \n\n");
    exit(1);
  };

  i = plt00();
  if(i==1)
  plotz("V1",2); /* Velocidad reducida en graficador HIPLOT */

  pltfr(1); /* Marco */
/* Coloca el Titulo en la grafica. */
 plttp(-3.5, -(0.08666*tam), 0.17, &titulo[0], 90.0, tam,1,pltmv);

 for(i=0; i<py ; i++)
 {
  fscanf(arch,"%f",&valor);
  if (valor < 0.0) {
    printf("\n !!! Elemento negativo: %f \n\n",valor);
    fclose(arch);
    exit(0);
  };
  total += valor;
  aval[i]=valor;
};

  dt = 6.28318/(double)(NP);

  plot((double)((RAD)+(ORXC)),(double)(ORYC),UP);
  for (i=0, th=dt; i<NP ; i++,th+=dt)
  plot((double)((ORXC)+(RAD)*cos(th)), (double)((ORYC)+(RAD)*sin(th)),DOWN);


  fact = (double)(NP)/total;
  facpc = 100.0/(NP);

  for(i=0,sum=0.0; i<py ; i++){
    poslet = sum + (aval[i]/2);
    sum += aval[i];

    totpc = (aval[i]*fact)*facpc;
    sprintf(porct,"%3.2f",totpc);
    fscanf(arch,"%s",cad);

    tam = pegacad(&cad[0],&porct[0]);

    cx= (double)((ORXC)+(RAD)*cos(((poslet*fact)*dt)+1.5708));
    cy= (double)((ORYC)+(RAD)*sin(((poslet*fact)*dt)+1.5708));

    if (cx < 0.0) {
      if (cy > 0.0)  plttp(cx-0.04,cy+0.06,0.08,&cad[0],90.0,tam,1,pltmv);
      else {  
       if (cy < -0.0009)
	  plttp(cx-0.04,cy-(tam*0.09),0.08,&cad[0],90.0,tam,1,pltmv); 
       else plttp(cx-0.04,cy+(tam*0.09),0.08,&cad[0],90.0,tam,1,pltmv);
      }
    } else { 
    if(cy > 0.0) plttp(cx+0.09,cy+0.08,0.08,&cad[0],90.0,tam,1,pltmv);
    else plttp(cx+0.09,cy-(tam*0.09),0.08,&cad[0],90.0,tam,1,pltmv);    
    };


    cx= (double)((ORXC)+(RAD)*cos(((sum*fact)*dt)+1.5708));
    cy= (double)((ORYC)+(RAD)*sin(((sum*fact)*dt)+1.5708));

    plot(cx,cy,UP);
    plot((ORXC),(ORYC), DOWN);
  };

  fclose(arch);
  pltho();
  closeplt();
}


/* leecadena.
   Funcion que se encarga de leer del archivo el titulo de la grafica,
   asi como tambien de contar su longitud en caracteres.
*/

int leecadena(FILE *ip,char *cad)
{
  char c;
  int i=0;

  do{
	 if((c = getc(ip)) == '"'){
	    while((c = getc(ip)) != '"'){
	      if (c == EOF) break;
	      *cad = c;
	      ++cad; ++i;
	    }
	 };

   } while((c != EOF) && (c!='"'));

   *cad = '\0';
   return(i);
}

int pegacad(char *p1, char *p2)
{
  int i=0;

   while(*p1 != '\0') {++i;  ++p1; } ;
   *p1 = ' '; ++p1; *p1 = ' '; ++p1; i+=2;
  while(*p2 != '\0') {
    *p1 = *p2; ++p1; ++p2; ++i;
  };
  *p2 = '\0';
  return(i);
}
