#include <stdio.h>
#include <math.h>
#include "plotp.h"

#define NT  40
#define NP  1000

/*
   SPHERE
   (20 ABRIL 1992)
   AMILCAR MENESES
*/

void sphcc(double *u, double x, double y, double z)
/* 
   [COORDENADAS DE UN PUNTO EN R^3]
   AMILCAR MENESES VIVEROS
   [27-ABR-93]
*/
{
  u[0]=x;
  u[1]=y;
  u[2]=z;
}
   
void sphps(double x[], double r, double th, double ph)
/*
  [PARAMETRIZACION ESFERICA]
  [20-ABR-93]
  AMILCAR MENESES VIVEROS
*/
{
  double s;
  s=r*sin(ph);
  x[0]=r*cos(ph);
  x[1]=s*cos(th);
  x[2]=s*sin(th);
}

void sphvp(double t[], double z[][3],double v[])
/* 
   [VECTOR PRODUCT]
   (VECTOR U) = (MATRIX Z)*(VECTOR V)
   [14-OCT-72] (FORTRAN)
   [18-JUN-93] (C)
*/
{ 
  int i;
  for(i=0; i<3; i++) 
    t[i] = z[i][0]*v[0] + z[i][1]*v[1] + z[i][2]*v[2];
}

void sphcv(double *z, double *x)
/* 
   [COPY VECTOR]
   (VECTOR Z)=(VECTOR X)
   [17-FEB-73]
*/
{
   z[0]=x[0];
   z[1]=x[1];
   z[2]=x[2];
}

void sphap(double w[], double o[][3], double z[], double a[])
/* 
   [AFFINE PRODUCT]
   W AND Z MAY BE THE SAME
   (VECTOR W)=(MATRIX 0)*VECTOR Z)+(VECTOR A)
   [13-FEB-73]
*/
{
  int i;
  double u[3]; 

  sphcv(u,z);
  for (i=0; i<3; i++)
    w[i] = o[i][0]*u[0] +o[i][1]*u[1] +o[i][2]*u[2] + a[i];
}

sphes(v,o,r,dt,dp,lp)
/* 
   [ESFERA ESPIRAL]
*/ 
double *v, o[][3];
double r,dt,dp,lp;
{ 
  int    i,j;
  double p,t;
  double w[3],u[3];

  p=0.0;
  t=0.0;
  sphcc(w,r,0.0,0.0);
  sphap(u,o,w,v);
  plot(u[0],u[1],0);
  for(i=1; i<=NP; i++, t+=dt, p+=dp) 
   {
     sphps(w,r,t,p);
     sphap(u,o,w,v);
     plot(u[0],u[1],(u[2]<0));
   };
}

void main(void)
{
  double v[3], o[3][3];
  double dt,dp,t,p,r;

  r=2.3;
  dt = 6.28318 / (double)(NT);
  dp = 3.14159 / (double)(NP-1);

  plt00();

  pltfr(6);

  sphcc(v, 0.0, 0.0, 0.0);
  plteu(&o[0][0], 90.0, 60.0, 45.0);
  sphes(v, o, r, dt, dp, NP);
  pltla("  ESFERA",8); 
  pltho();
  closeplt();
}
