/*          UNIVERSIDAD AUTONOMA DE PUEBLA
    DEPARTAMENTO DE APLICACION DE MICROCOMPUTADORAS
	ESFERA CON ARCOS DE LATITUD Y LONGITUD
	      [J.P.H.E.   JULIO-1992]
*/
#include <math.h>
#include <stdio.h>
#include "plotp.h"

#define  npu  35
double  O1[3][3];                      /* Matriz de rotacion de Euler */

void d19sp( PH, TH, P)           /* Funcion de movimiento de la pluma */
double PH,TH;
int    P;
{
   double the,phi,x,y,z,u,v,w,ro,fi;

   the = 3.14159 * TH;
   phi = 6.28318 * PH;
   x   = sin(the) * cos(phi);
   y   = sin(the) * sin(phi);
   z   = cos(the);
   u   = O1[0][0]*x + O1[0][1]*y + O1[0][2]*z;
   v   = O1[1][0]*x + O1[1][1]*y + O1[1][2]*z;
   w   = O1[2][0]*x + O1[2][1]*y + O1[2][2]*z;
   ro  = sqrt(u*u+v*v);
   fi  = atan2(v,u)/6.28318;
   pltpo(fi, ro, (int)(P && (w >= 0.0)) ); /* Proyeccion al plano polar */
}


main()
{   int i, j;
    double  phmi  = 0.0;
    double  phma  = 2.0*3.14159;
    double  thmi  = 0.0;
    double  thma  = 3.14159;
    double  dph   = (phma-phmi)/(double) (npu-1);
    double  dth   = (thma-thmi)/(double) (npu-1);
    double  ph, th;

    plteu(&O1[0][0], -10.0, 30.0, 70.0);

    plt00();
    plotz("V1 ",3);
    pltfr(4);
    pltso(3.10, 3.10, 0.0, 0.0);
    pltig(phmi, thmi, 1, d19sp);
    pltig(phma, thma, 2, d19sp);

    th   = thmi;                             /* Traza arcos de latitud */
    for(i=0; i < npu; i++) {
	ph  =  phmi;
	pltig(ph,th, 3, d19sp);
	for(j=1; j < npu; j++) {
	    ph  =  ph + dph;
	    pltig(ph, th, 4, d19sp);
	}
	th = th + dth;
    }

    ph   = phmi;                            /* Traza arcos de longitud */
    for(i=0; i < npu; i++)  {
	th  = thmi;
	pltig(ph,th, 3, d19sp);
	for(j=1; j < npu; j++)  {
	    th = th + dth;
	    pltig(ph, th, 4, d19sp);
	}
	ph = ph + dph;
    }

    ph  = phmi;             /* Enmarca la esfera con una circunferencia */
    pltig(ph, 3.14159, 3, pltpo);
    for(j=1; j < npu; j++) {
	ph  = ph + dph;
	pltig(ph, 3.14159, 4, pltpo);
    }

    pltlla("Esfera con Arcos de Latitud y Longitud", 38, " ",0, 4);
    pltho();
    pltclose();
}
