/*          UNIVERSIDAD AUTONOMA DE PUEBLA
    DEPARTAMENTO DE APLICACION DE MICROCOMPUTADORAS
	    TRIPLE SUPERFICIE (vistr)
	    [J.P.H.E.     JUNIO-1993]
*/
#include <stdio.h>
#include <math.h>
#include "plotp.h"

#define NX     37    /* Dim. de las matrices de valores para la super. */
#define NY     18
#define xmi   -3.1415
#define xma    3.1415
#define ymi   -3.0
#define yma    3.0

double WA[NX][NY], WB[NX][NY], WC[NX][NY];

main()
{
 int    i,j;
 double dx, dy, zmi, zma, x, y;
 char   in[50];
 char   bu[] = {"Triple Superficie z = sen(x), z = cos(x) , z = x*x - y*y"};

 dx  = (xma-xmi)/(double)(NX-1);
 dy  = (yma-ymi)/(double)(NY-1);
 zmi = 3.0*sin(xmi);
 zma = zmi;

 x   = xmi;                /* Calculo de los valores de las superficies */
 for(i=0 ; i < NX; i++)  {
      y = yma;
      for (j=0 ; j < NY; j++) {
	   WA[i][j] =  3.0*sin(x);
	   WB[i][j] =  x*x - y*y;
	   WC[i][j] =  3.0*cos(x);
	   if(WA[i][j] < zmi) zmi=WA[i][j]; /* Calculo del valor maximo */
	   if(WA[i][j] > zma) zma=WA[i][j]; /* y del valor minimo       */
	   if(WB[i][j] < zmi) zmi=WB[i][j];
	   if(WB[i][j] > zma) zma=WB[i][j];
	   if(WC[i][j] < zmi) zmi=WC[i][j];
	   if(WC[i][j] > zma) zma=WC[i][j];
	   y -= dy;
      }
      x += dx;
 }
 dx = fabs(zma-zmi)/10.0;
 x  = zmi - dx;    y = zma + dx;

 plt00();
 plotz("P1 V1 ",6);
 pltfr(1);
 plot( 2.0,  0.5, UP);                           /* Marco Superior */
 plot(-2.0,  0.5, DOWN);   plot(-2.0, 4.5, DOWN);
 plot( 2.0,  4.5, DOWN);   plot( 2.0, 0.5, DOWN);
 plot( 2.0, -0.5, UP);                          /* Marco Inferior */
 plot( 2.0, -4.5, DOWN);   plot(-2.0, -4.5, DOWN);
 plot(-2.0, -0.5, DOWN);   plot( 2.0, -0.5, DOWN);

 pltso(1.9, 1.9, 0.0, 2.5);    pltcolor(10);           /* de color verde */
 vistr(x,&WA[0][0],&WB[0][0],&WC[0][0],y,NX,NX,NY,NY,0.08,0.08,0.0,1,-1, pltca);

 plotr();

 pltso(1.9, 1.9, 0.0, -2.5);
 plotz("P1 ",3);               pltcolor(11);            /*  de color azul  */
 vistr(x,&WA[0][0],&WB[0][0],&WC[0][0],y,NX,NX,NY,NY,0.08,0.08,0.0,1,1, pltca);
 plotr();                      pltcolor(2);

 i = pltgi(in, xmi, 'X', xma, ymi, 'Y', yma);
 pltlla(bu, (sizeof(bu) - 1), in, i, 3);
 pltho();
 pltclose();
}
