/*            DEM19S - FUNCION DE ONDA TETAEDRICA
SUPERFICIE (PLTSV) Y CONTORNOS SOBRE UNA ESFERA (PLTKP, PLTKX, PLTKY)
     H.V.M.    21-MAY-1975          A.B.C.G.     1992
*/
#include <math.h>
#include "plotp.h"

#define  NT  45
#define  NP  90

double  O1[3][3];
double  EF[NP][NT];

void d19sp( PH, TH, P)
double PH, TH;
int    P;
{
  double the,phi,x,y,z,u,v,w,ro,fi;

   the = 3.14159 * TH;
   phi = 6.28318 * PH;
   x   = sin(the) * cos(phi);
   y   = sin(the) * sin(phi);
   z   = cos(the);
   u   = O1[0][0]*x + O1[0][1]*y + O1[0][2]*z;
   v   = O1[1][0]*x + O1[1][1]*y + O1[1][2]*z;
   w   = O1[2][0]*x + O1[2][1]*y + O1[2][2]*z;
   ro  = sqrt(u*u+v*v);
   fi  = atan2(v,u)/6.28318;
   pltpo(fi, ro, (int)(P && (w >= 0.0)) );
}

main()
{
   int     i, j;
   double  s, dt, dp, t, p, tf, pf, ra;
   char    bu1[]  = {"Funcion de onda tetraedrica"};
   char    bu[]   = {"Superficie y contornos sobre una esfera"};

   s = -1.0;
   plteu(&O1[0][0], 10.0, -60.0, 10.0);

   dt = 3.14159 / (double)(NT-1);
   dp = 6.28318 / (double)(NP);
   t  = 3.14159;

   for(i = 0 ; i < NT ; i++) {
       p  = 0.475;
       for (j = 0 ; j < NP ; j++) {
	    tf = 0.67 * (1.0 + 0.5*cos(3.0*t) + s*0.1667*cos(9.0*t) );
	    pf = 0.67 * (1.0 + 0.5*sin(3.0*p) - s*0.1667*sin(9.0*p) );
	    ra = tf*pf*0.95;
	    EF[j][i] = ra;
	    p += dp;
       }
       t -= dt;
   }

 plt00();
 plotz("P1 V1 ",6);
 pltfr(1);
 plot( 2.0,  0.5, UP);                           /* Marco Superior */
 plot(-2.0,  0.5, DOWN);   plot(-2.0, 4.5, DOWN);
 plot( 2.0,  4.5, DOWN);   plot( 2.0, 0.5, DOWN);
 plot( 2.0, -0.5, UP);                          /* Marco Inferior */
 plot( 2.0, -4.5, DOWN);   plot(-2.0, -4.5, DOWN);
 plot(-2.0, -0.5, DOWN);   plot( 2.0, -0.5, DOWN);

 pltso(2.0, 2.0, 0.0, 2.5);         pltcolor(11);
 pltsv(&EF[0][0], NP, NT, 1.0, &O1[0][0], vissp, pltpo);
 plotr();

 pltso(1.9, 1.9, 0.0, -2.5);
 plotz("P1 ",3);       pltcolor(11);       /*  de color azul la esfera  */
 pltkp(0.0 , &EF[0][0], 1.0, 20, 3, NP, 2, NT, d19sp);

 plotz("P2 ",3);     pltcolor(12);        /*  rayado en X de rojo */
 pltkx(0.50, &EF[0][0], 1.0, NP, NT, d19sp);

 plotz("P3 ",3);      pltcolor(10);         /*  rayado en Y de verde   */
 pltky(0.80, &EF[0][0], 1.0, NP, NT, d19sp);

 pltcolor(2);
 pltig(0.0, 0.0, 1, pltpo);
 pltig(1.0, 1.0, 2, pltpo);
 pltig(0.0, 1.0, 3, pltpo);
 p = 100.0/99.0;
 t = 0.0;
 for(i=0; i<100; i++, t += p) pltig(t, 1.0, 4, pltpo);
 plotr();

 pltlla(bu, (sizeof(bu)-1), bu, 0, 1);
 plttp(-1.4, 0.0, -0.11, bu1, 0.0, (sizeof(bu1)-1), 1, pltmv);
 pltho();
 pltclose();
}
