/*          UNIVERSIDAD AUTONOMA DE PUEBLA
     DEPARTAMENTO DE APLICACION DE MICROCOMPUTADORAS
    SUPERFICIES (ANGULO DE VISTA, CORTE y PERSPECTIVA)
	    [J.P.H.E            AGOSTO-1997]
*/

#include <math.h>
#include <stdio.h>
#include "plotp.h"

#define  XMI      -3.1415
#define  XMA       3.1415
#define  YMI      -2.0
#define  YMA       2.0
#define  fun(x,y)  sin(x)+0.0*y

#define  NX     30                         /* Numero de divisiones en X */
#define  NY     30                         /* Numero de divisiones en Y */
#define  NZ     30                         /* Numero de divisiones en Z */
#define  AV    0.75                      /* Angulo de vista en radianes */
#define  LA    0.3                            /* Desplazamiento lateral */
#define  PR    0.0		       /* Desplazamiento de profundidad */
#define  CP   -6.0                  /* Centro de proyeccion en el eje Y */
#define  PP   -3.0          /* Plano de proyeccion paralelo al plano XZ */


#define  ex(x)   ((x-X1) * SCX)     /* Interpolacion lineal             */
#define  wy(y)   ((y-Y1) * SCY)     /* Pasar xmi - xma, ymi - yma       */
#define  zz(z)   ((z-Z1) * SCZ)     /* zmi - zma al cubo unitario       */


static  double  SCX,  SCY,   SCZ;


static  double  X1 = 0.0,   X2 = 1.0;  /* Coordenadas del cubo unitario */
static  double  Y1 = 0.0,   Y2 = 1.0;
static  double  Z1 = 0.0,   Z2 = 1.0;


double VZ[40][40];             /* Matriz para los valores de Z = F(X,Y) */


void   d19to( x, y, z, P)           /* Proyeccion de las coordenadas 3D */
double x, y, z;                     /* al plano X,Y                     */
int    P;
{

    x  = x + y*cos(AV);                      /*    Angulo de Vista  */
    y  = z + y*sin(AV);
    pltcas( 0.33*(x+1.0), 0.33*(y+1.0), P);

/*    x  = x + LA*y;                                    Corte
    y  = z + PR*y;
    pltcas( (x+LA)/(2.0*LA+1.0), (y+PR)/(2.0*PR+1.0), P);

    x  = ( PP - CP ) / (y - CP) * x;                  Perspectiva
    y  = ( PP - CP ) / (y - CP) * z;
    pltcas( 0.3+x,  0.3+y,  P);                      */

}


main()
{
    double  xmi  =  XMI,    xma  =  XMA;
    double  ymi  =  YMI,    yma  =  YMA;
    double  dx   =  (XMA-XMI)/(double) (NX-1);
    double  dy   =  (YMA-YMI)/(double) (NY-1);
    double  x,   y,   z,  dz,  zmi,  zma;
    int     i,   j;

    zmi = fun(xmi, ymi);        /* El valor minimo y maximo deben */
    zma = zmi;                  /* pertenecer a la funcion        */

    x   = xmi;
    for( i = 0 ; i < NX; i++ )  {
	 y = ymi;
	 for( j = 0 ; j < NY; j++ ) {
	      VZ[i][j]    =  fun(x, y);
	      if( VZ[i][j] < zmi) zmi = VZ[i][j];
	      if( VZ[i][j] > zma) zma = VZ[i][j];
	      y += dy;
	 }
	 x += dx;
    }
    dz = (zma-zmi)/(double)(NZ-1);

    X1 = xmi;     Y1 = ymi;       Z1 = zmi;
    X2 = xma;     Y2 = yma;       Z2 = zma;

    if(X2 != X1) SCX = 1.0/(X2-X1);
    if(Y2 != Y1) SCY = 1.0/(Y2-Y1);
    if(Z2 != Z1) SCZ = 1.0/(Z2-Z1);


    plt00();
    plotf(-1);
    pltfr(0);                    /* No trazar marco, define el origen */


    x = xmi;     pltcolor(2);  /* Trazar coordenada de profundidad, VERDE */
    for(j=0; j < NX; j++) {
	y = ymi;    z = VZ[j][0];
	d19to(ex(x), wy(y), zz(z), UP);
	for(i=1; i < NY; i++) {
	    y += dy;  z = VZ[j][i];
	    d19to(ex(x), wy(y), zz(z), DOWN);
	}
	x += dx;
    }

    y = ymi;     pltcolor(6);   /* Trazar coordenada horizontal, CAFE */
    for(j=0; j < NY; j++) {
	x = xmi;    z = VZ[0][j];
	d19to(ex(x), wy(y), zz(z), UP);
	for(i=1; i < NX; i++) {
	    x += dx;  z = VZ[i][j];
	    d19to(ex(x), wy(y), zz(z), DOWN);
	}
	y += dy;
    }

    x  =  xmi;        pltcolor(3);          /* Trazar el eje X, AZUL */
    d19to(ex(x), wy(0.0), zz(0.0), UP);
    for(j=1; j < NX; j++) {
	x  =  x + dx;
	d19to(ex(x), wy(0.0), zz(0.0), DOWN);
    }

    y  = ymi;         pltcolor(4);         /* Trazar el eje Y, ROJO */
    d19to(ex(0.0), wy(y), zz(0.0), UP);
    for(j=1; j < NY; j++)  {
	y  = y + dy;
	d19to(ex(0.0), wy(y), zz(0.0), DOWN);
    }

    z  = zmi;         pltcolor(5);          /* Trazar el eje Z, MORADO */
    d19to(ex(0.0), wy(0.0), zz(z), UP);
    for(j=1; j < NZ; j++)  {
	z = z + dz;
	d19to(ex(0.0), wy(0.0), zz(z), DOWN);
    }
    pltho();
    pltclose();
}
