#include <math.h>

#include "plotp.h"

#define MX 34
#define MY 34
#define NX 34
#define NY 34
#define x1 -3.0
#define x2  3.0
#define y1 -2.6
#define y2  2.4
#define ak  3.5

/*

   (DEM08)   (4/MAR/85) Superficies dobles.
   Conv. a C, 13/MAR/89.

*/

 double S1[MX][MY],S2[MX][MY];

void main(void)
{
 int    i,j;
 double xmin,xmax,dx,dy,x,y,h,rr,p1,p2;

  dx = ((x2)-(x1))/(double)(MX-1);
  dy = ((y2)-(y1))/(double)(MY-1);

  xmin = 1.0;
  xmax = -1.0;

  y = y1;

  for (j = 0 ; j < MY ; j++)
  {
    x = x1;
    for (i = 0 ; i < MX ; i++)
    {
      h = 0.01 * (x+y) * (x-y);
      rr = 0.1 * (x*x + 2.0*y*y + 2.0*x*y);
      p1 = -1.5 * exp(-0.33*rr) + 5.0 * exp(-(ak)*rr);
      p2 = rr*rr * exp(-0.667*rr);
      S1[i][j] = 0.5 * tanh( 0.25*p1-0.25) + 0.5;
      S2[i][j] = 0.5 * tanh(-0.20*p2+0.25-h) + 0.5;
      if (S1[i][j] < xmin) xmin = S1[i][j];
      if (S1[i][j] > xmax) xmax = S1[i][j];
      if (S2[i][j] < xmin) xmin = S2[i][j];
      if (S2[i][j] > xmax) xmax = S2[i][j];
      x += dx;	};
    y += dy;  };

  plt00();
  pltfr(1);
  plot(-3.25, 0.0, 0);
  plot(3.25, 0.0, 1);
  pltso(3.25, 4.50, 0.0, 0.0);

  pltso(2.00, 2.00, 0.00, -2.25);
  visnh();
visdo(0.0,&S1[0][0],&S2[0][0],1.0,NX,MX,NY,MY,0.2,0.2,0.0,1,1,pltca);
  plotr();

  pltso(2.00, 2.00, 0.00, 2.25);
  visnh();
visdo(0.0,&S1[0][0],&S2[0][0],1.0,NX,MX,NY,MY,0.2,0.2,0.0,1,-1,pltca);
  plotr();
  pltho();
 closeplt();

}
