#include <math.h>

#include "plotp.h"

#define MX 27
#define MY 27
#define NX 27
#define NY 27
#define ji 2
#define c1 2.0
#define c2 0.5
#define c3 0.75
#define ef 1.025

/*
   PROGRAM DEM10
   (DEM10)    7/MAR/85
   (Conv. a C, 22.MAR.89)
*/

  double S1[MX][MY],S2[MX][MY],S3[MX][MY];

void main(void)
{
  int    i0,j0,jj,ii,i,j;
  double x,y,rr1,rr2,rr3,r1,r2,r3,p1,p2,p3;

  i0 = (MX*ji)/2;
  j0 = (MY*ji)/2;
  for (jj=0 ; jj < MY ; jj++)
  {
    j = (jj+1)*ji;
    for (ii=0 ; ii < MX ; ii++)
    {
      i = (ii+1)*ji;
      x = 0.1*(double)(i-i0);
      y = 0.1*(double)(j-j0);
      rr1 = (x+1.0)*(x+1.0) + (y-1.2)*(y-1.2);
      rr2 = (x-1.1)*(x-1.1) + (y+0.25)*(y+0.25);
      rr3 = (x-1.7)*(x-1.7) + (y-1.05)*(y-1.05);
      r1 = sqrt(rr1);
      r2 = sqrt(rr2);
      r3 = sqrt(rr3);
      if (r1 <= c1)  p1 = 3.5*(1.0-r1/c1);
      if ((r1 > (ef*c1)) && (r1 < (1.66*c1)))  p1 = 3.5*(1.0-ef);
      if (r1 > (1.66*c1))  p1 = 0.02*(double)((i+j) % 2) ;
      if (r2 <= (ef*c2))  p2 = 3.0*(1.0-r2/c2);
      if ((r2 > (ef*c2)) && (r2 < (2.0*c2)))  p2 = 3.0*(1.0-ef);
      if (r2 > (2.0*c2))  p2 = 0.02*(double)((i+j) % 2) ;
      if (r3 <= (ef*c3))  p3 = 4.0*(1.0-r3/c3);
      if ((r3 > (ef*c3)) && (r3 < (2.0*c3)))  p3 = 4.0*(1.0-ef);
      if (r3 > (2.0*c3)) p3 = 0.02*(double)((i+j) % 2) ;
      S1[ii][jj] = tanh(0.25*p1-0.3);
      S2[ii][jj] = tanh(-0.25*p2);
      S3[ii][jj] = tanh(-0.25*p3+0.3);
    };  };

  plt00();
  pltfr(1);
  plot(-3.25, 0.0, UP);
  plot( 3.25, 0.0, DOWN);
  pltso(3.25, 4.50, 0.0, 0.0);

  pltso(2.0, 2.0, 0.0, -2.25);
  visnh();
vistr(-0.5, &S1[0][0], &S2[0][0], &S3[0][0], 0.5, NX, MX, NY, MY,
       0.2, 0.2, -0.025, 1, 1, pltca);
  plotr();

  pltso(2.00, 2.00, 0.0, 2.25);
  visnh();
vistr(-0.5, &S1[0][0], &S2[0][0], &S3[0][0], 0.5, NX, MX, NY, MY,
       0.2, 0.2, -0.025, 1, -1, pltca);
  plotr();

  pltho();
  closeplt();
}
