#include <math.h>
#include "plotp.h"

/*
   DEM12.C
   (DEM120) plot84.
   9.MAR.85.
   23.MAR.89.
*/

#define	 fscale   2.0
#define   nx       51
#define   ny	   51
#define   x10	  -8.0
#define   y20	  -8.0
#define   x20	  -10.0
#define   y10	  -10.0

char rot1[] = {"Rotacion de +54 gr "};
char rot2[] = {"Rotacion de +18 gr "};

  double ZE[nx][ny];

void main(void)
{
  int    i,j;
  double dx,dy,y1,y2,x1,x2,rr1,rr2,r2,s2,p1,p2;
/* double r1;  */

  dx = 18.0 / (double)(nx-1);
  dy = 18.0 / (double)(ny-1);

  for (j=0 ; j < ny ; j++)
  {
    y1 = y10 + dy*(double)(j);
    y2 = y20 + dy*(double)(j);

    for (i=0 ; i < nx ; i++)
    {
      x1 = x10 + dx*(double)(i);
      x2 = x20 + dx*(double)(i);
      rr1 = x1*x1 + 2.0*y1*y1 + 2.0*x1*y1;
  /*    r1 = sqrt(rr1);  */
      rr2 = 2.0*x2*x2 - y2*y2 + 2.0*x2*y2;
      r2 = sqrt(fabs(rr2));
      s2 = ((r2-1.0) > 0.0) ? (r2-1.0) : 0.0;
      p1 = rr1*rr1*exp(-rr1);
      p2 = (s2*s2*s2*s2) * exp(-fabs(rr2));
      ZE[i][j] = tanh(fscale*(0.2*p1 + 5.0*p2 - 0.005*x2*y1));	};  };

  plt00();
  pltfr(1);
  pltso(3.25, 4.50, 0.00, 0.00);
  pltso(3.25, 2.00, 0.00,-2.25);
  plot( 3.25,-2.00, UP);
  plot(-3.25,-2.00, DOWN);
  plot(-3.25, 2.00, DOWN);
  plot( 3.25, 2.00, DOWN);
  plot( 3.25,-2.00, DOWN);
  plotr();
  pltso(3.25, 2.00, 0.00, 2.25);
  plot( 3.25,-2.00, UP);
  plot(-3.25,-2.00, DOWN);
  plot(-3.25, 2.00, DOWN);
  plot( 3.25, 2.00, DOWN);
  plot( 3.25,-2.00, DOWN);
  plotr();
  pltso( 3.25, 2.00, 0.00,-2.25);
  symbol(-1.083, 1.771, 0.114, rot1, 0.0, 19);

  pltrv(-1.0, &ZE[0][0], 1.0, nx, ny, 54.0, pltca);

  plotr();

  pltso( 3.25, 2.00, 0.00, 2.25);
  symbol(-1.083, 1.771, 0.114, rot2, 0.0, 19);

  pltrv(-1.0, &ZE[0][0], 1.0, nx, ny, 18.0, pltca);

  pltho();
  closeplt();
}
