#include <math.h>

#include "plotp.h"

#define  NT  27
#define  NP  90


/*
     (dem140)   11/MAR/85
*/


  void dem14a( Z, X, Y)
  double Z[],X[],Y[];
  {
    int i,j,k,l,m,n;

    for(i = 0 ; i < 3 ; i++)
       for (j = 0 ; j < 3 ; j++)
          {
            l = j + (i*3);
            Z[l] = 0.0;
            for (k = 0 ; k < 3 ; k++)
             {
              m = k + (i*3);
              n = j + (k*3);
	      Z[l] = 1.02*( Z[l] + X[m] * Y[n]);
	     }
	  }
   }

   double EF[NP][NT];

void main(void)
{
   int i,j;
   double dt,dp,th,ph,tf,pf;
   double t0[3][3], t2[3][3], t3[3][3];
   double t1[3][3];

    t1[0][0] =  1.0  ; t1[1][0] =  0.0  ; t1[2][0] = -0.1 ;
    t1[0][1] =  0.0  ; t1[1][1] =  1.0  ; t1[2][1] =  0.0 ;
    t1[0][2] =  0.1  ; t1[1][2] =  0.0  ; t1[2][2] =  1.0 ;

    t2[0][0] =  1.0  ; t2[1][0] =  0.0  ; t2[2][0] =  0.1 ;
    t2[0][1] =  0.0  ; t2[1][1] =  1.0  ; t2[2][1] =  0.0 ;
    t2[0][2] = -0.1  ; t2[1][2] =  0.0  ; t2[2][2] =  1.0 ;

   plteu(&t0[0][0], 26.64, 65.92, 39.25);

  dt = 3.14159 / (double)(NT-1);
  dp = 6.28318 / (double)(NP);
  th = 0.0;

  for(i = 0 ; i < NT ; i++)
  {
    ph = 0.5;
    for (j = 0 ; j < NP ; j++)
    {
      tf = 0.5 * ( 1.25 + sin(3.0*th) );
      pf = 1.25 + sin(3.0*ph);
      EF[j][i] = 0.45 * tf * pf;
      ph += dp;
    };
    th += dt;
  };

  plt00();
  pltfr(1);
  pltso( 3.25, 4.50, 0.00, 0.00);
  pltso( 3.25, 2.00, 0.00,-2.25);
  plot ( 3.25,-2.00, UP);
  plot (-3.25,-2.00, DOWN);
  plot (-3.25, 2.00, DOWN);
  plot ( 3.25, 2.00, DOWN);
  plot ( 3.25,-2.00, DOWN);
  plotr();
  pltso( 3.25, 2.00, 0.00, 2.25);
  plot ( 3.25,-2.00, UP);
  plot (-3.25,-2.00, DOWN);
  plot (-3.25, 2.00, DOWN);
  plot ( 3.25, 2.00, DOWN);
  plot ( 3.25,-2.00, DOWN);
  plotr();
  plotf(-1);
  pltso( 2.00, 3.25, 0.00,-2.25);

  dem14a(&t3[0][0], &t2[0][0], &t0[0][0]);

  pltsv(&EF[0][0], NP, NT, 1.0, &t3[0][0], vissp, pltpo);

  plotr();

  pltso( 2.00, 3.25, 0.00, 2.25);
  dem14a(&t3[0][0], &t1[0][0], &t0[0][0]);
  pltsv(&EF[0][0], NP, NT, 1.0, &t3[0][0], vissp, pltpo);
  plotr();

  pltla("DEM140",6);

  pltho();
  closeplt();
}
