#include <math.h>

#include "plotp.h"

#define NT  32
#define NP  100

/*
   (DEM16)	(11.MAR.85)
   (Conv. a C, MAR.92)
*/

   double EF[NP][NT];

void main(void)
{
   int    i,j;
   double O[3][3];
   double dt,dp,t,p,r1,r2,rr;

  plteu(&O[0][0], 153.35 ,65.92 ,140.75);

  dt = 3.14159 / (double)(NT-1);
  dp = 6.28318 / (double)(NP);
  t  = 0.0;

  for (i=0 ; i < NT ; i++)
  {
    p  = 0.5;
    for (j=0 ; j < NP ; j++)
    {
      r1 = sin(2.0*(t+p));
      r2 = sin(3.0*(t-p));
      rr = r1*r1+r2*r2+0.6*r1*r2;
      EF[j][i] = 0.4/(0.4+rr);
      p  += dp;   };
      t  += dt;   };

  plt00();
  pltfr(5);
  pltso(3.0, 3.0, 0.0, 0.0);
  plotf(-1);

  pltsv(&EF[0][0], NP, NT, 1.0, &O[0][0], vissp, pltpo);

  pltla("DEM16",5);
  pltho();
  closeplt();
}
