#include <math.h>

#include "plotp.h"

#define  NTT  11
#define  NPP  31
#define  K    10
#define  F    1.0

/*

     (dem170)   13/MAR/85

*/

   double EFF[NPP][NTT],GEE[NPP][NTT];

void main(void)
{
   int i,j,ii,jj,nt,np;
   double dt,dp,t,p,tf,pf;
   double o1[3][3],o2[3][3];


    o1[0][0] =  0.577; o1[1][0] =  0.577; o1[2][0] =  0.577;
    o1[0][1] = -0.707; o1[1][1] =  0.000; o1[2][1] =  0.707;
    o1[0][2] =  0.408; o1[1][2] = -0.816; o1[2][2] =  0.408;
/*    o2[0][0] =  0.577; o2[1][0] = -0.577; o2[2][0] =  0.577;
    o2[0][1] =  0.707; o2[1][1] =  0.000; o2[2][1] = -0.707;
    o2[0][2] =  0.408; o2[1][2] =  0.816; o2[2][2] =  0.408; */


  nt = (NTT -1)* K+ 1;
  np = (NPP -1)* K;
  dt = 3.14159 / (double)(nt-1);
  dp = 6.28318 / (double)(np);

  for(i = 0 ; i < NTT ; i++)
    for (j = 0 ; j < NPP ; j++)
    {
      ii = K * i;
      jj = K * j;
      t  = ii * dt;
      p  = jj * dp + 0.5;
      tf = 0.4 + 0.8 * sin(0.5 * t);
      pf = 0.4 *(4.0 + sin(p) + 0.1 * sin(3.0 * p));
      EFF[j][i] = tf * pf + (0.1 * (float)((2 + ii + jj) % 2) );
      GEE[j][i] = F;
    }


  plt00();
  pltfr(5);
  pltso( 3.00, 3.00, 0.00, 0.00);
  plotf(-1);

  pltov(&EFF[0][0], &GEE[0][0], NPP, NTT, 1.0, &o1[0][0], pltpo);

  pltho();
  closeplt();
}
