#include <stdio.h>
#include <math.h>
#include "plotp.h"

/*
   [dem28]
   DEMOSTRATION OF THE POTENTIAL FELT BY TWO PARTICLES IN A GAUSSIAN
   WELL. THE SURFACE ARISES FROM THE USE OF HYPERSPHERICAL HARMONICS
   IN QUANTUM MECHANICS.  HERE IT IS USED TO ILLUSTRATE A TECHNIQUE
   OF SKETCHING OUT A COARSE SURFACE INTO WHICH IS INSERTED A DENSER
   REGION OF SPECIAL INTEREST.  THE DETAIL WHICH IS DESIRED IS THE
   SHAPE OF THE BOTTOM OF THE TROUGHS CROSSING AT THE CENTER OF THE
   DRAWING.
   [6-OCT-74]
   Enero 95.
*/

#define NX 75
#define NY 75
#define ex(i)  0.0667*(double)(i-57)
#define wy(j)  0.0487*(double)(j-41)

void dems1(z1, z, z2, nx, ny)
double z1,z[],z2;
int nx,ny;
{

  visnh();
  visds(z1,&z[0],z2,1,nx,nx,1,ny,ny,0.2,0.2,-8,8,pltca);
  visnh();
  visds(z1,&z[0],z2,1,57,nx,41,ny,ny,0.2,0.2,-1,1,pltca);
}


  double ve[NX][NY];

void main(void)
{
  double x1,x2,r1,r2,rr;
  int    i,j;

  for (i=0; i < NX; i++)
   for (j=0; j < NY; j++)
   {
     x1 = ex(i+1);
     x2 = wy(j+1);
     r1 = exp(-x1*x1);
     r2 = exp(-x2*x2);
     rr = exp(-0.25*(x1-x2)*(x1-x2));
     ve[i][j] = tanh(0.4*(-2.0*r1-2.0*r2+rr)); };

  plt00();

  pltfr(1);
  plotf(-1);


  dems1(-1.0, &ve[0][0], 1.0, NX, NY);

/*    pltkp(-1.0, &ve[0][0], 1.0, 51, 5, NX, 5, NY, pltca); */


  pltla("[dem28]",7);
  pltho();
  closeplt();
}
