#include "plt.h"

#define UP  0

#define vi(z)	((z-Z1)*(Z2-z))

void pltkx(double Z1, double ZE[], double Z2, int NX, int NY,
	   void (*graff)())

/*       pltkx.c
   [X-Crosshatching]
   Rayado en direccion X.

  [Z1,Z2] Intervalo de rayado en direccion X.
   (H.V.McIntosh, 5.ENE.75)
   (Fco. Gil, 25.ENE.85)
   (Conv. a C, G.Cisneros, 19.JUL.88)
   (Angel Canto, 20.Feb.89)
*/
{
  int i,j,i1,i2;
  double x,y,dx,dy;

  if (NX < 2 || NY < 2) return;
  x = 0.0;
  y = 0.0;
  dx = 1.0/(double)(NX-1);
  dy = 1.0/(double)(NY-1);
  for (j=1 ; j <= NY ; j += 2)
  {
    (*graff)(x, y, UP);
    for (i=2 ; i <= NX ; i++ , x+=dx)
     {
	i1 = ((i-2)*NY) + j-1;
	i2 = ((i-1)*NY) + j-1;
	pltil(x, y, vi(ZE[i1]), x+dx, y, vi(ZE[i2]), graff); };
    dx = -dx;
    y += dy;
    if (j >= NY) return;
    (*graff)(x, y, UP);
    for (i=2 ; i <= NX ; i++ , x += dx)
     {
	i1 = ((NX-i+1)*NY) + j;
	i2 = ((NX-i)*NY) + j;
	pltil(x, y, vi(ZE[i1]), x+dx, y, vi(ZE[i2]), graff); };
    dx = -dx;
    y += dy; }
}
