#include "plt.h"

#define vi(z)	((z-Z1)*(Z2-z))

void pltky(double Z1, double ZE[], double Z2, int NX, int NY,
	   void (*graff)())

/*       pltky.c
   [Y-Crosshatching].
   Rayado en direccion Y.

  [Z1,Z2] intervalo de rayado en direccion Y.
   (H.V.McIntosh, 5.ENE.75)
   (Fco. Gil, 25.ENE.85)
   (Conv. a C, G.Cisneros, 19.JUL.89)
   (Angel Canto, 20.Feb.89)
*/
{
  int i,j,i1,i2;
  double x,y,dx,dy;

 if (NX < 2 || NY < 2) return;
 x = 0.0;
 y = 0.0;
 dx = -1.0/(double)(NX-1);
 dy = -1.0/(double)(NY-1);
 for (i=1 ; i <= NX; i += 2)
  {
    (*graff)(x, y, UP);
    for (j=2 ; j <= NY ; j++ , y += dy)
     {
       i1 = ((NX-i)*NY) + NY-j+1;
       i2 = i1-1;
       pltil(x, y, vi(ZE[i1]), x, y+dy, vi(ZE[i2]), graff); };
    dy = -dy;
    x += dx;
    if (i >= NX) return;
    (*graff)(x, y, UP);
    for (j=2; j <= NY; j++ , y += dy)
     {
       i1 = ((NX-i-1)*NY) + j;
       i2 = i1-1;
       pltil(x, y, vi(ZE[i1]), x, y+dy, vi(ZE[i2]), graff); };
    y = -dy;
    x += dx; }
}
