;	--------------------------------------------------
;		 UNIVERSIDAD AUTONOMA DE PUEBLA
;	 DEPARTAMENTO DE APLICACION DE MICROCOMPUTADORAS
;
;	            	 GRAFICA ARCH.EXT
;
;	Envia al trazador DMP-29 el contenido de ARCH.EXT
;
;	J.P.H.E.  (FEB-1993) sincronizacion adecuada
;	---------------------------------------------------

FCB	equ     5CH		; FCB
BUFF	equ	80H		; DMA
COMX    equ     03F8H		; PUERTO BASE DEL COM1

_text    segment public 'code'
         assume  cs:_text
         assume  ds:_text
         assume  es:_text
         assume  ss:_text
 
        ORG      0100H

INICIO: 

	mov	sp,pila		; Definir la pila
	mov	al,[buff]	; Se proporcionaron argumentos?
	or 	al,al		;
	jz	let0		; NO, poner mensaje y salir
        call	i8250           ; SI, iniciar el COM1
        call	idmp29		; Iniciar el DMP29
	mov	dx,offset FCB   ; abre el archivo 
        mov	ah,15           ;
        int	21H
        cmp	al,255
        jz	let1
        xor	ax,ax
        mov	bx,dx
        mov	[bx+32],al	; Inicia el FCB
        mov	[bx+33],ax
        mov	[bx+35],ax
	call	cte		; Asegura que no hay caracteres pend.
	call	lerr		; Lee un sector del archivo
loop0:	call	cte		; Se oprimio una tecla?
	jnz	pctrlc		; SI, prueba si es Ctrl-C
	call	gnb		; NO, Leer un caracter del archivo
	cmp	al,1AH		; Fin de archivo? 
	jz	fin		; SI
        cmp	al,0AH		; NO, es el LF?
        jz	loop0           ; SI, no se procesa
	call	e8250		; Enviar el caracter al 8250
        call	sr8250          ; Se recibio un caracter del DMP-29?
	or	al,al
        jz	loop0		; No, continuar la transmicion
        cmp	al,19		; Se recibio el Ctrl-S ?
        jnz	loop0		; NO, continuar la transmicion
recr:	call	r8250		; SI, esperar el control-q
	cmp	al,17		; Se recibio el Ctrl-Q ?
        jnz	recr            ; NO, se espera por el
	jmp	loop0		; SI, continuar con la transmicion

pctrlc:	cmp	al,3
	jz	fin
        jmp	loop0

LERR:   mov	dx,offset FCB	; Lee un bloque del archivo.
        mov     ah,20
        int	21H
        cmp	al,2		
        jz      let2		; Error de lectura
	cmp	al,1		; NO mas datos
	jz	fin
        mov	si,offset BUFF	; Carga la direccion del DMA
	ret

gnb:    mov	al,[si]		; Obtiene un caracter.
	push    ax
        inc	si		; Actualiza el apuntador.
        cmp	si,00100H
        jz      gnble		; Si, leemos otro sector
	pop     ax
        ret
gnble:	call	lerr
        pop     ax
        ret


fin:    mov	si,offset fcdmp
        call	lidmp
fin1:	mov	ah,0		; Salir de MS_DOS
	int	21H

let0:	mov	dx,offset letr0
	mov	ah,9
	int	21H
	jmp	fin1

let1:	mov	dx,offset letr1
	mov	ah,9
	int	21H
	jmp	fin

let2:	mov	dx,letr2
	mov	ah,9
	int	21H
	jmp	fin

cte:	push	dx
	mov	dl,0FFH
        mov	ah,6
        int	21H
	pop	dx
	ret


i8250:  mov	dx,COMX+3	; Iniciar el COM1
        mov     al,080H		; Habilitar el divisor
        out     dx,al
        mov     dx,COMX
        mov     ax,12		; Divisor a 9600 bps
        out     dx,al
        inc     dx
        mov     al,ah
        out     dx,al
        mov     dx,COMX+3
        mov	al,7		; 8 bits, 2 stop bits
        out     dx,al
        mov	dx,COMX+4
        mov	al,11		; Inicializacion recomendada
        out     dx,al
clrgs:  mov     dx,COMX+5
        in      al,dx
        mov     dx,COMX
        in      al,dx
        mov     dx,COMX+6
        in      al,dx
        mov     dx,COMX+2
        in      al,dx
        in      al,dx
        test    al,1
        jz      clrgs
        ret
     

r8250:	push	dx		; RECIBIR, un caracter del COM1
        mov     dx, COMX+5	; Puerto de estado
len:    in      al, dx
	test    al, 1		; Dato disponible
        jz	len
        mov	dx, COMX	; Puerto de datos
        in	al, dx
	pop	dx
        ret

sr8250: xor	ax, ax
	push	dx
        mov	dx, COMX+5	; Puerto de estado
        in	al, dx
        test	al, 1		; Dato disponible
        jz	fsr
	mov	dx, COMX	; Puerto de datos
	in	al, dx
fsr:	pop	dx
	ret

e8250:	push	dx		; ENVIAR, un caracter al COM1
        push	ax
	mov	dx, COMX+5	; Puerto de estado
lsa:	in	al, dx
        test	al, 20H		; Transmitir buffer vacio
        jz	lsa
        mov	dx, COMX	; Puerto de datos
        pop	ax
        out	dx, al
        pop	dx
	ret


prn:	push	ax
	push	bx
        push	cx
	push	dx
	push	si
	pushf
	mov	ah,2
        mov     dl,al
	int	21H
	popf
        pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret

idmp29: mov	si,offset cidmp
lidmp:	mov	al,[si]
        or	al,al
	jz	fidmp
        call	e8250
        inc	si
        jmp	lidmp
fidmp:	ret


text    ends


cidmp:  db	';: UP0 HP1 V8 A',0
fcdmp:  db	'U U P0 H',0
letr0:	db	0DH,0AH,'La forma de ejecutar el comando es:',0DH,0AH
	db	0DH,0AH,'       GRAFICA NOMBRE.EXT',0DH,0AH,'$'
letr1:	db	0DH,0AH,'El archivo especificado no existe',0DH,0AH,'$'
letr2:	db	0DH,0AH,'Error al leer un sector del archivo',0DH,0AH,'$'
        db	100 dup (?)
pila:	db	0

	end	INICIO
