#include <stdio.h>
#include <dos.h>
#include <alloc.h>
#include <pcxhead.h>
#include <string.h>

#define LONG_FNAME  15

union REGS regs;

int DISK = 0;          /* Indicador del dispositivo de salida.  */

static char BUFF[50];  /* BUFFER almacenamiento de car. movs. plotz().  */
static int  ICO = 0;   /* Contador para el max. de BUFFER max. 50.      */
static int  ILE = 0;   /* Contador ciclico del numero de movs. max. 50. */

static FILE *fileplt;  /* Apuntador archivo de salida de movs o PCX     */

static char *imagen;   /* Apuntador en memoria de la imagen generada. */

unsigned int wide, deep;        /* Ancho y profundidad de la imagen.    */

int bytes=128;                  /* Bytes necesarios para una linea.     */
int MaxX=1024, MaxY=758;        /* Resolucion del dispositivo en pixels.*/
int Mode=6;                     /* Modo de video actual.                */

char *Video2pcxl(char *fname);
char *farptr(char *p,long l);   /* regresa un apuntador far p+l */
unsigned int pixels2bytes(unsigned int n);
PackPcxFile(char *p, FILE *fp, int bytes);
WritePcxLine( char *p, FILE *fp, int bytes);
void SetPix(char *buf,int x,int y);


void pltpalette(int colorv,int paleta)

/*       plotsal.c

   [Define color del fondo]
   Interrupcion 0x10, Servicio 0x0b
   Cambia la paleta, el fondo, o el color del borde.
   colorv = define BH.
   paleta = define BL.
   Selecciona color: BH = 0, BL = Color.
   Selecciona Paleta: BH = 1, BL = Paleta.
   (Angel Canto, Dic.93)
*/
{
     regs.h.ah = 0x0b;
     regs.h.bh = colorv;
     regs.h.bl = paleta;
     int86( 0x10, &regs, &regs);
}


int pltint(void)

/*       plotsal.c
	 [Lee un entero]
	 (Angel Canto, Oct.93)
*/
{     int i;
      scanf("%d", &i);
      return i;
}

float pltfloat(void)

/*       plotsal.c
	 [Lee un flotante]
	 (Angel Canto, Oct.93)
*/
{     float x;
      scanf("%f", &x);
      return x;
}

void pltdsply(char *let)

/*       plotsal.c
    [Recibe letreros para ser desplegados]
    (Angel Canto, Oct.93)
*/
{
  printf("%s",let);
}

void pltname(char pname[], int longn)

/*       plotsal.c
     [Obtiene nombre archivo de salida]
     (Angel Canto, Oct.93)
*/
{
    int i = 0;
    while (((pname[i++] = getchar()) != '\n') && (i < longn));
       pname[i-1] = '\0';
}

void pltclose(void)

/*       plotsal.c
   [Cierra archivo de movimientos o regresa el video a modo texto]
    (Angel Canto, 10.Dic.88)
*/
{
  int  i;
  char pausa = ' ';
  char name[LONG_FNAME];

  switch (DISK) {
  case 1 :
  case 5 : for (i=0 ; i < 7 ; i++)
	   putc('\032',fileplt); /* pone fin de archivo  ^Z (DOS)*/
	   fclose(fileplt);
	   break;
  case 2 :
  case 3 :
  case 4 : scanf("%c",&pausa);
	   regs.h.al = 3;   /* Regresa modo texto!!!*/
	   regs.h.ah = 0;
	   int86(0x10, &regs, &regs);
	   break;
  case 6 : pltdsply("\n\n Archivo con extension (PCX): ");
	   pltname(&name[0], LONG_FNAME);
	   Video2pcxl(name);
	   fclose(fileplt);
	   break;
  default: break;
  }

}


void closeplt(void)
{  pltclose(); }




void plotz(char iar[], int n)

/*       plotsal.c
   [Recibe los movimientos de la pluma y decide si
    salen a un archivo o a video]
    (Fco. Gil, 14.MAY.85) [F80].
    (Angel Canto, 10.Dic.88) ["C"].
*/
{
  int i;

  if (DISK != 0)
   /* Salida por Disco. */
  {
  switch (DISK) {
  case 1:   for (i = 0 ; i < n ; i++) {
	     BUFF[ICO] = iar[i]; ++ICO;};
	    if (iar[n-1] != '_')
	    break;
	    for(i = 0; i < ICO ; i++) putc(BUFF[i],fileplt);
	    putc(0x0a,fileplt);
	    ICO = 0 ; ++ILE;
	    if (ILE >= 50) {pltdsply("."); ILE = 0;};
	    break;

  case 5:   for(i = 0; i < n ; i++) putc(iar[i],fileplt);
	    ++ILE;
	    if (ILE >= 50) {pltdsply("."); ILE = 0;};
	    break;
     }
   }
   else { pltdsply(" !! Device error."); exit(1); };
}



void pltdk(int outp)

/*       plotsal.c
   [Inicializa el dispositivo de salida ha usarse]
   Opciones de seleccion outp:
	 1   salida a archivo para graficar en plotter HIPLOT.
	 2   salida a monitor CGA 320 x 200.
	 3   salida a monitor VGA 640 x 480.
	 4   salida a monitor SVGA RTVGA, 1024 x 758.
	 5   salida a archivo para graficar en plotter Calcomp.
	 6   salida a archivo PCX 1024 x 758.
    (Fco. Gil, 11.DIC.85) [F80].
    (Angel Canto, Dic.93).
*/
{
  char name[LONG_FNAME],*pimg;
  long i,totbytes;

  switch (outp) {
  case 1 :   pltdsply(" (HIPLOT) File Name (.PLT), Output: ");
	     pltname(&name[0], LONG_FNAME);
	     if((fileplt = fopen(name,"w")) == NULL)
	      { pltdsply(" File Open Error : ");
		pltdsply(name);
		exit(1); }
	     else DISK = 1;
	     break;

  case 2 :   regs.h.al = 5; /* modo cga 320 x 200 */
	     regs.h.ah = 0;
	     int86( 0x10, &regs, &regs);
	     DISK = 2;
	     break;

  case 3 :   regs.h.al = 0x12;  /* vga 16 colores 640x480 */
	     regs.h.ah = 0;
	     int86( 0x10, &regs, &regs);
	     DISK = 3;
	     break;

  case 4 :    regs.h.al = 0x28; /*modo SVGA 1024 x 758 */
	      regs.h.ah = 0;
	      int86( 0x10, &regs, &regs);
	      DISK = 4;
	      break;

  case 5 :   pltdsply(" (Calcomp) File Name (.PLT), Output: ");
	     pltname(&name[0],LONG_FNAME);
	     if((fileplt = fopen(name,"wb")) == NULL)
	      { pltdsply(" File Open Error : ");
		pltdsply(name);
		exit(1); }
	     else DISK = 5;
	     break;

 case 6:     pltdsply("\n Generando Grafica !!!\n");
	     bytes = MaxX/8;
			wide = MaxX;    /* Pantalla completa.   */
			deep = MaxY;
	     totbytes = (long)bytes * (long)MaxY;
	     if((imagen=(char *)farmalloc(totbytes))!=NULL) {
	       pimg = imagen;
	       for (i=0; i<totbytes; i++){
		  *pimg = 0;
		  pimg = farptr( pimg, 1L);
		  }
	       }
	     else { pltdsply("\n\n Error al crear Memoria virtual.\n");
		    exit(1);}
	     DISK = 6;
	     break;


  default:   pltdsply("\n\n (pltdk) Device Error !!!!\n");
	     exit(1);
	     break;
  }
}

void pointv(int x, int y, int color)

/*       plotsal.c
     [Si se crea archivo PCX escribe punto en memoria virtual ]
     [en otro caso Grafica un punto en video en coordenadas absolutas]
     [usando BIOS.]
     (x,y)  Coordenadas del punto.
     color  Color del punto.
     (Angel Canto, Nov.92)
*/
{
  if (DISK == 6)  {
    if (ICO++ >= 1000) {pltdsply("."); ICO = 0; };
       SetPix(imagen, x, y);
  }
  else {
     regs.x.dx = y;
     regs.x.cx = x;
     regs.h.ah = 12;
     regs.h.al = color;
     int86(0x10,&regs,&regs);
  };
}

/* Enciende un pixel en el bufer buf en las coordenadas x, y. */

void SetPix(char *buf,int x,int y){
  unsigned char n;
  char *p;

  if(x>=0 && x<wide && y>=0 && y<deep){
	p = farptr(buf, (long)y* (long)bytes);
	   n=p[x>>3];
	   n=n | (0x80 >> (x % 8) );
	   p[x>>3] = n;
  }
}


/* Funciones para codificar imagenes Monocromaticas BIN */
/* al formato PCX, version para imagenes grandes (+64k) */
/* Version para el modelo de memoria Large.             */
/* Bit Mapped Graphics                                  */
/* Steve Rimmer.                                        */
/* Ed. Windcrest.                                       */
/* Modif. Saturnino Julio De La Trinidad H.             */
/*              6/FEB/1995                              */


PCXHEAD header;         /* Donde se guarda el encabezado. */

char DefaPallete[]={    /* Paleta por defecto con porcentajes RGB.      */
     0,   0,   0,     0,  0, 0xaa,     0,0xaa,   0,     0,0xaa,0xaa,
  0xaa,   0,   0,  0xaa,  0, 0xaa,  0xaa,0xaa,   0,  0xaa,0xaa,0xaa,
  0x55,0x55,0x55,  0x55,0x55,0xff,  0x55,0xff,0x55,  0x55,0xff,0xff,
  0xff,0x55,0x55,  0xff,0x55,0xff,  0xff,0xff,0x55,  0xff,0xff,0xff
  };



/* Toma la imagen del area de video y la almacena en el formato PCX.    */
char *Video2pcxl(char *fname)
{
  FILE *fp;
  char  *p;
    /* Intentamos abrir el archivo destino */
    if((fp=fopen(fname,"wb"))!=NULL){

			bytes = pixels2bytes(wide);

			if(Mode<5)
			  p=(char *)MK_FP( 0xB800, 0);
			  else
/* p=(char *)MK_FP( 0xA000, 0); */
			  p = imagen;
			PackPcxFile(p,fp,bytes);
			fclose( fp );
     }else printf("Error de apertura en: %s\n",fname);
}

/* empaca linea para ser almacenada. */

PackPcxFile(char *p, FILE *fp, int bytes) {
  int i, n;

  /* Escribe el encabezado */
  WritePcxHeader( fp );

  /* Empaqueta las lineas. */
  for(i=0; i<deep; i++) {
     n = WritePcxLine(p, fp, bytes);
     p = farptr( p, (long) bytes);      /* p = p+bytes  */
     }
  return(n);
}

/* Escribe un pixel en el archivo de salida. */

WritePcxLine( char *p, FILE *fp, int bytes)
{
   unsigned int i=0, j=0, t=0;

   do {
	i=0;
	while( (p[t+i] == p[t+i+1] ) && ((t+i) < bytes) && (i<63))
	   i++;
	if(i>0) {
	   fputc( i | 0xC0, fp);
	   fputc( ~p[t], fp);   /* ~ */
	   t+=i;
	   j+=2;
	   }else{
	   if( ((~p[t]) & 0xC0)==0xC0 ) { /* Caso Critico ~byte=clave. */
	      fputc(0xC1, fp);
	      ++j;
	      }
	   fputc( ~p[t++], fp); /* ~ */
	   ++j;
	   }
	} while( t<bytes );
   return(j);
}




/* Escribe el encabezado al archivo PCX. */
WritePcxHeader( FILE *fp )
{
  memset((char *)&header, 0, sizeof(PCXHEAD));  /* Limpia bufer con 0's */
  header.manufacturer=0x0A;
  header.version=3;
  header.encoding=1;

  /* Bits per pixel:    1 para monocromatico
			4 para 16 colores ( Posiblemente EGA o VGA )
			8 para 256 colores ( Super VGA ) */

  header.bits_per_pixel=1;
  header.xmin=header.ymin=0;    /* Definen las dimensiones de la imagen */
  header.xmax=wide-1;           /* en el archivo en cuestion.           */
  header.ymax=deep-1;
  header.hres= MaxX;    /* Resolucion del dispositivo que creo la imagen. */
  header.vres= MaxY;
  FillPalette( &header.palette );       /* Coloca la paletta por default. */
  header.colour_planes=1;
  header.bytes_per_line=bytes;
  header.palette_type=2;        /* 1 escala de gris, 2 color completo.  */

  return( fwrite( (char *)&header, 1, sizeof(PCXHEAD), fp));
}

FillPalette( char s[] )
{
 int i;

 for( i=0; i<48; ++i)
   s[i] = DefaPallete[i];
 }

unsigned int pixels2bytes(unsigned int n)
{
  if(n & 0x0007) return( (n>>3)+1 );
    else  return( n>>3 );
}

char *farptr(char *p,long l)    /* regresa un apuntador far p+l */
{
  unsigned int seg, off;

  seg = FP_SEG( p );
  off = FP_OFF( p );
  seg += (off / 16);
  off &= 0x000f;
  off += (unsigned int) (l & 0x000fL);
  seg += (l / 16L);
  p =  MK_FP(seg, off);
  return( p );
}


/* END */
