#include <time.h>
#include "plt.h"

#define tx      -3.25
#define ty      -5.125
#define th       0.2
#define trx     -4.50
#define try     -3.875
#define ex      -1.35
#define ey      -5.125
#define eh       0.15
#define ne      33

/* o ex = -1.31, ne = 31.       */

#define erx     -0.10
#define ery     -3.875

static char chain[33] = "PLOT90c-ICUAP  DD/MM/AA  HH:MM:SS";

void pltla(char text[], int n)

/*       pltla.c
   [Label]
   Escribe un letrero "text" de longitud "n" como etiquetas bajo el
   marco chico, ademas escribe la version del paquete (la fecha y
   la hora de graficacion).
   Checa la posicion de la grafica si es normal o rotada, en cual-
   quir caso coloca la linea en su posicion.
   (H.V.McIntosh, 21.MAR.74)
   (Fco. Gil, 29.ENE.85)
   (Conv. a C, G.Cisneros, 29.JUN.88)
   (Angel Canto, 21.Ene.89)
*/
{
   int         l;
   double      sx,sy;
   struct tm   *timeptr;
   time_t      secsnow;

  timezone = 8 * 60 * 60;
  time(&secsnow);
  timeptr = localtime(&secsnow);

  sprintf(&chain[15],"%2d",timeptr -> tm_mday);
  if (chain[15] == ' ') chain[15] = '0';
  chain[17] = '/';
  sprintf(&chain[18],"%2d",((timeptr -> tm_mon) + 1));
  if (chain[18] == ' ') chain[18] = '0';
  chain[20] = '/';
  sprintf(&chain[21],"%2d",timeptr -> tm_year);
  chain[23] = ' '; chain[24] = ' ';
  sprintf(&chain[25],"%2d",timeptr -> tm_hour);
  if (chain[25] == ' ') chain[25] = '0';
  chain[27] = ':';
  sprintf(&chain[28],"%2d",timeptr -> tm_min);
  if (chain[28] == ' ') chain[28] = '0';
  chain[30] = ':';
  sprintf(&chain[31],"%2d",timeptr -> tm_sec);
  if (chain[31] == ' ') chain[31] = '0';

   plotl(&sx, &sy, &l);
   if (l == 0)
   {
     plttp(tx, ty, th, text, 0.0, n, 1, pltmv);
     plttp(ex, ey, eh, chain, 0.0, ne, 1, pltmv); }
   else
   {
     plttp(trx, try, th, text, 0.0, n, 1, pltmv);
     plttp(erx, ery, eh, chain, 0.0, ne, 1, pltmv); }
}
