#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include "plotp.h"

void pltlla(char texto[], int nct, char inter[], int nci, int m)

/*       pltlla.c
   Coloca dos letreros en la grafica, uno en la parte superior y otro en
   la parte inferior, tambien se coloca la fecha y la hora.
   Todos los letreros son centrados.
   Etiquetar una grafica.

texto[]    letrero de la parte superior.
nct        numero de caracteres en texto[] ( max. 58 o 69 depende de la forma )
inter[]    letrero de la parte inferior.
nci        numero de caracteres en inter[] ( max. 58 o 69 depende de la forma )
m          tipo de marco que se emplea, 1, 2, 3, 4, 5, o 6.
   (MAYO - 1993, J.P.H.E.)
*/
{
   int    i, l, ite, it, iti;
   double sx,sy;
   char   *cfe;
   time_t t1, t2;
   char  tempo[70], temp1[70], ia  = ' ';
   float tx  = -3.20, ty  =  4.95, th = 0.11;
   float ex  = -3.20, ey  = -4.75, eh = 0.11;
   float hx  = -0.90, hy  = -5.15;
   float trx = -4.00, try =  3.75;
   float erx = -4.00, ery = -3.55;
   float hrx = -1.15, hry = -3.95;

   t1  = time(&t2);
   cfe = ctime(&t1);
   cfe+= 4;

   plotl(&sx, &sy, &l);
   if( l != 0  )   ite = 69 - nct;
   if( l == 0  )   ite = 58 - nct;
   if( m >= 4  )   ite = 58 - nct;
   if( ite < 0 ) { nct += ite;   ite = 0; }
   ite = (ite/2)+1;
   it  = ite;
   for( i=0; i < ite;  i++) tempo[i] = ia;
   for( i=0; i < nct; i++, ite++) tempo[ite] = texto[i];
   it  += nct;

   if( l != 0  )   ite = 69 - nci;
   if( l == 0  )   ite = 58 - nci;
   if( m >= 4  )   ite = 58 - nci;
   if( ite < 0 ) { nci += ite;   ite = 0; }
   ite = (ite/2)+1;
   iti = ite;
   for( i=0; i < ite; i++) temp1[i] = ia;
   for( i=0; i < nci; i++, ite++) temp1[ite] = inter[i];
   iti += nci;

   if ( m >=4 ) {
	ty -= 1.2;    ey += 1.2;      hy += 1.2;   try = ty;
	ery = ey;     hry = hy;       trx = tx;    erx = ex;
   }

   if (l == 0) {
      plttp(tx, ty, -th, tempo, 0.0, it,  1, pltmv);
      plttp(ex, ey, -eh, temp1, 0.0, iti, 1, pltmv);
      plttp(hx, hy, -eh, cfe,   0.0, 20,  1, pltmv);
   }
   else  {
      plttp(trx, try, -th, tempo, 0.0, it,  1, pltmv);
      plttp(erx, ery, -eh, temp1, 0.0, iti, 1, pltmv);
      plttp(hrx, hry, -eh, cfe,   0.0, 20,  1, pltmv);
   }
}
