#include "plot.h"
#include "plt.h"

static double x0, y0;
static int    s0;

void pltmc(double x, double y, int s)

/*       pltmc.c
    [Margin Compressed]  (Comprimir los trazos que quedan fuera del
			    marco, y colocarlos en el borde de 1")
     PLTMC  mueve la pluma al punto (x,y) en una hoja 8.5" * 11".
     el margen dentro de este cuadro es de una pulgada asi que la
     superficie de trazo es de 6.5" * 9", movimientos que rebasan
     estas dimensiones se transforman con la tangente hiperbolica
     para  ajustar los movimientos del margen al infinito  dentro
     del area de una pulgada del margen.  Se emplea interpolacion
     lineal  para obtener  una interseccion  precisa de cualquier
     segmento de linea con el margen interno.
     Si s = .true. , baja la pluma y despues realiza el movimiento.
     Si s = .false., anota la pos. de la pluma y no la mueve.
     (15-MAY-74 Harold V. McIntosh)
     (09-Abr-93 "C", J.P.H.E.)
*/
{
   double x1, y1, x2, y2, ex, wy, hx, hy;
   int    p1, p2, q,  lf;

   plotl(&hx, &hy, &lf);
   if(!s) { s0 = s;   x0 = x;   y0 = y;   return; }
   x1 = x0;     y1 = y0;
   x2 = x;      y2 = y;
   pltmt(&x1, &y1, &p1, &x2, &y2, &p2, &q);
   if(!s0) {
      pltma (&ex, &wy, x0, y0);
      lf ? plot(-wy, ex, (int) 0) : plot(ex, wy, (int) 0);
   }
   if (!q) {
	pltme(x0, y0, x, y);
	s0 = s;   x0 = x;   y0 = y;   return;
   }
   if (p1) pltme(x0, y0, x1, y1);
   lf ? plot(-y2, x2, (int) 2) : plot(x2, y2, (int) 2);
   if(p2) pltme(x2, y2, x, y);
   s0 = s;   x0 = x;   y0 = y;
}
