#include <math.h>
#include "plot.h"

#define  eq(x,y)  fabs(x-y) <= (1.0e-5)

static   double   x0, y0;
static   int      s0;

void   pltms(double x, double y, int s)

/*       pltms.c
     [Margin Suppressed]     (Suprimir los trazos fuera del marco)
     PLTMS  mueve la pluma al punto (x,y) en una hoja tamano carta.
     sin embargo se mantiene un borde de una pulgada desde el filo
     de la hoja, en el cual no  se permite  el  trazo.  Se  emplea
     interpolacion lineal para obtener  una  interseccion  precisa
     del segmento de la linea con este margen.
     (x,y) Coordenadas del punto.
     Si s = .true. , baja la pluma y despues realiza el movimiento.
     Si s = .false., anota la pos. de la pluma y no la mueve.
     (15-MAY-74 Harold V. McIntosh)
     (09-Abr-93 "C", J.P.H.E.)
*/
{
   double x1, y1, hx, hy;
   int    p0, p1, q, lf;

   if( !s ) {
       s0 = 1;  x0 = x;  y0 = y;  return;
   }
   if( eq(x, x0) && eq(y,y0) ) {
       s0 = 1;  x0 = x;  y0 = y;  return;
   }
   x1 = x;
   y1 = y;
   pltmt(&x0, &y0, &p0, &x1, &y1, &p1, &q);
   if( !q ) {
       s0 = 1;  x0 = x;  y0 = y;  return;
   }
   plotl(&hx, &hy, &lf);
   if(s0 || p0) lf ? plot(-y0, x0,(int) 0): plot(x0, y0, (int) 0);
   lf ? plot(-y1, x1, (int) 2) : plot(x1, y1, (int) 2);
   s0 = p1;  x0 = x;  y0 = y;
}

