#include <math.h>
#include "plot.h"

#define  ex(y)    *x1+(y-*y1)*((*x2-*x1)/(*y2-*y1))
#define  wy(x)    *y1+(x-*x1)*((*y2-*y1)/(*x2-*x1))

void   pltmt(double *x1, double *y1, int *p1, double *x2, 
	     double *y2, int *p2, int *q)

/*       pltmt.c
	[Margin Trimmer]                          (Algoritmo de Ventana)
	los puntos z1 = (x1,y1) y z2=(x2,y2) son ajustados para contener
	unicamente la parte de la linea que pertenece a la pagina del
	trazo cuyas mitades son hx y hy.
	p1 = .true.   se ajusto z1.
	p2 = .true.   se ajusto z2.
	q  = .true.   la linea definida por z1-z2 es parcial o totalmente
		      visible.
	(02-NOV-73 Harold V. McIntosh)
	(09-Abr-93 "C", J.P.H.E.)
*/
{  double hx, hy, x0, y0;
   int    lf;

   plotl(&hx, &hy, &lf);
   *p1 = 0;
   if (fabs(*x1) > hx) {
	if (*x1 == *x2) {
	   x0 = 0.5 * (*x1 + *x2);
	   y0 = 0.5 * (*y1 + *y2);
	   *q  = (fabs(x0) < hx) && (fabs(y0) < hy);
	    return;
	}
	x0  = (*x1 >= 0.0) ?  hx : -hx;
	*y1 = wy(x0);
	*x1 = x0;
	*p1 = 1;
   }
   if (fabs(*y1) > hy ) {
	if (*y1 == *y2) {
	   x0 = 0.5 * (*x1 + *x2);
	   y0 = 0.5 * (*y1 + *y2);
	   *q  = (fabs(x0) < hx) && (fabs(y0) < hy);
	    return;
	}
	y0 = (*y1 >= 0.0) ? hy : -hy;
	*x1 = ex(y0);
	*y1 = y0;
	*p1 = 1;
    }
    *p2 = 0;
    if (fabs(*x2) > hx) {
	if (*x1 == *x2)  {
	   x0 = 0.5 * (*x1 + *x2);
	   y0 = 0.5 * (*y1 + *y2);
	   *q  = (fabs(x0) < hx) && (fabs(y0) < hy);
	    return;
	 }
	x0 = (*x2 >= 0.0) ? hx : -hx;
	*y2 = wy(x0);
	*x2 = x0;
	*p2 = 1;
    }
    if (fabs(*y2) > hy) {
	if ( *y1 == *y2) {
	    x0 = 0.5 * (*x1 + *x2);
	    y0 = 0.5 * (*y1 + *y2);
	    *q = (fabs(x0) < hx) && (fabs(y0) < hy);
	    return;
	}
	y0  = (*y2 >= 0.0) ? hy : -hy;
	*x2 = ex(y0);
	*y2 = y0;
	*p2 = 1;
    }
    x0  = 0.5 * (*x1 + *x2);
    y0  = 0.5 * (*y1 + *y2);
    *q  = (fabs(x0) < hx) && (fabs(y0) < hy);
}
