#include "vis.h"

void pltiv(double Z1, double ZE[], double Z2, int NX, int NY, 
	   double RO, double TI, void (*pl)())

/*       pltiv.c
   [Inclined view].
   Vista inclinada.
   La superficie debe ser inclinada en la direccion de el observador
   y despues rotada sobre el eje vertical antes de generar una linea
   oculta. La inclinacion es cero cuando se ve directamente por en--
   cima, y de 90 grados cuando se ve desde el piso. La inclinacion--
   es positiva cuando es en direccion del observador y negativa cuan-
   do esta fuera de el. El angulo de rotacion es cero cuando el eje
   de las Y's corre directamente fuera del observador, y es positivo
   cuando el eje de las X's se mueve en direccion de el.

   (Z1,Z2)    Rango de la funcion de valores.
   ZE[]       Arreglo de valores de la funcion.
   NX,NY      Dimension ZE[NX][NY].
   RO,TI      Angulo de rotacion, inclinacion en grados.
   pl         Funcion de conversion de coordenadas. (pltca usual).
   (H.V.McIntosh, 30.MAY.75)
   (Fco. Gil, 23.DIC.84)
   (Conv. a C, G. Cisneros, 15.JUL.88)
   (Angel Canto, 16.Mar.89)
*/
{
 double O[3][3];

  visnh();
  plteu(O, RO, TI, 0.0);
  visis(Z1, ZE, Z2, 1, NX, NX, 1, NY, NY,&O[0][0], pl);
}
