#include "vis.h"

void pltrv(double Z1, double ZE[], double Z2, int NX, int NY, 
	   double TH, void (*pl)())

/*       pltrv.c
   [Rotated view]
   Vista rotada.
   Programa para producir un dibujo en perspectiva de una funcion e-
   valuada y definida en coordenadas cartesianas. exhibiendo arcos -
   en la superficie paralela al eje coordenado. Para mayor variedad-
   en presentacion, la figura entera debe ser rotada a traves de un-
   angulo, que debe estar especificado en grados.
   (Z1,Z2)     Rango de los valores de la funcion.
   ZE[]        Arreglo con los valores de la funcion.
   NX,NY       ZE[NX][NY].
   TH          Angulo de rotacion (-90.0 < TH < 90.0) en grados.
   pl          Funcion de conversion de coordenadas (usual pltca)
   (H.V.McIntosh, 8.MAY.75)
   (Fco. Gil, 23.DIC.84)
   (Conv. a C, G. Cisneros, 15.JUL.88)
   (Angel Canto, 16.Mar.89)
*/
{
  visnh();
  if ((TH > -90.0) && (TH < 90.0))
  visrs(Z1, ZE, Z2, NX, NX, NY, NY, TH, pl);
}
