#include "vis.h"

void plttv(double Z1, double ZE[], double Z2, int N,
           int M, void (*pl)())

/*       plttv.c
   [Triangular view]
   Vista triangular.
   Programa para producir un dibujo en perspectiva de una funcion de-
   finida sobre una unidad triangular en terminos de coordenadas homo-
   geneas. Los valores de la funcion ocupan la porcion triangular ba-
   ja de la matriz cuadrada ZE[M][M] de la cual solo el fragmento
   ZE[N][N] seran escalados al rango Z1,Z2.
   pl Podria ser pltca().

   (Z1,Z2)   Rango de los valores de la funcion.
   ZE[]      Arreglo de los valores de la funcion.
   N,M       Dimension del arreglo de la funcion.
   pl        Funcion de conversion de coordenadas.
   (H.V.McIntosh, 11.MAY.75)
   (Fco. Gil, 26.DIC.84)
   (Conv. a C, G. Cisneros, 15.JUL.88)
   (Angel Canto, 16.Mar.89)
*/
{
  visnh();
  vists(Z1, ZE, Z2, N, M, pl);
}
