#include <math.h>

#include "vis.h"

#define SIZE 150

void pviis(double Z1, double ZE[], double Z2, int J1, int J2, 
	   int MX, int I1, int I2, int MY, double O[], double S, 
	   void (*pl)())

/*       pviis.c
   [Inclined sequence]
   Secuencia inclinada para colores. Positivo o negativo distinto color.
   ABS(F(x,y)) es la funcion que se grafica.

   (Z1,Z2)   Rango de los valores ZE.
   ZE[]      Arreglo con los valores de la funcion.
   J1,J2     Rango de X (Coordenada horizontal).
   MX,MY     ZE[MX][MY].
   I1,I2     Rango de Y (Coordenada de profundidad).
   O[]       Matriz ortogonal definiendo inclinacion.
   S         =1.0 Grafica parte positiva, =-1.0 parte negativa.
   pl        Funcion de conversion de coordenadas. (usual pltca).
   (H.V.McIntosh, 31.MAY.75)
   (Fco. Gil, 23.DIC.84)
   (Conv. a C, G. Cisneros, 15.JUL.88)
   (Angel Canto, 16.Mar.89)
*/
{
  int P[SIZE];
  double  U[SIZE],V[SIZE];
  int l,m,nl,nm,n,il,iu,mm,nn,i0,j0,k0,i,j,k,ix,kk;
  double zs,duj,euj,dvi,evi,eu,ve,uu;
  /*  double te;  */

 l = -(int)(fsgn(O[3]));
 m =  (int)(fsgn(O[0]));
 nl = sgn(l);
 nm = sgn(m);
 n = nl * nm;
 il = I1 - abs(m);
 iu = I2 + abs(m);
 mm = l * MY;
 nn = 1;
 /*  te = 0.5*(double)(nl+1);  Nunca se usa PLOT84  */
 zs = 1.0 / (Z2-Z1);
 duj = 1.0 / (double)(MX-1);
 euj = duj * (double)(l);
 dvi = 1.0 / (double)(MY-1);
 evi = dvi * (double)(m);

 i0 = (nm > 0) ? (I1+m) : (I2+m);
 j0 = (nl > 0) ? J1 : J2;
 k0 = (n > 0) ? -1 : SIZE;

 do{
    do{
	k = k0;
	i = visbd(i0, iu, il);
	j = j0;
	ix = (i-1) + ((j-1)*MY);
	eu = duj*(double)(j-1) - 0.5;
	ve = dvi*(double)(i-1) - 0.5;

	do{
	   if((i >= I1) || (i <= I2))
	   {
	     k = visbd(k+n, SIZE-1, 0);
	     uu = zs*(fabs(ZE[ix])-Z1);
	     U[k] = (double)(0.667*(O[0]*eu + O[3]*ve + O[6]*uu) + 0.5);
	     V[k] = (double)(0.667*(O[1]*eu + O[4]*ve + O[7]*uu) + 0.5);
	     P[k] = (int)((S*ZE[ix] >= 0.0));   };
	     i  -= m;
	     ix -= m;
	     ve -= evi;
	     if ((i < I1) || (i > I2)) break;
	     k = visbd(k+n, SIZE-1, 0);
	     uu = zs*(fabs(ZE[ix])-Z1);
	     U[k] = (double)(0.667*(O[0]*eu + O[3]*ve + O[6]*uu) + 0.5);
	     V[k] = (double)(0.667*(O[1]*eu + O[4]*ve + O[7]*uu) + 0.5);
	     P[k] = (int)((S*ZE[ix] >= 0.0));
	     j += l;
	    ix += mm;
	    eu += euj;
	  } while ((j >= J1) && (j <= J2));

	kk = ((k+2-n*k)/2) -1;
	visch(&U[kk], &V[kk], &P[kk], 
	      (int)((SIZE+1-n*(SIZE-2*(k+1)+1))/2),
	      nn, pl);
	nn = -nn;
	i0 += m;
      } while ((i0 >= il) && (i0 <= iu));
    j0 += l;
   } while ((j0 >= J1) && (j0 <= J2));
}
