#include "vis.h"

void pviiv(double Z1, double ZE[], double Z2, int NX, int NY, 
	   double RO, double TI, double S, void (*pl)())

/*       pviiv.c
   [Inclined view]
   Vista inclinada.
   La superficie debe ser inclinada en la direccion del observador
   y rotada sobre el eje vertical antes de generar una linea oculta.
   La inclinacion es cero cuando se ve por encima, y de 90 grados
   cuando se ve desde el piso. La inclinacion es positiva cuando es
   en direccion del observador y negativa cuando esta fuera de el.
   El angulo de rotacion es cero cuando el eje de las Y's corre di-
   rectamente fuera del observador, y es positivo cuando el eje po-
   sitivo de las X's se mueve hacia el.

   (Z1,Z2)    Rango de los valores de ZE.
   ZE[]       Arreglo con los valores de la funcion.
   NX,NY      Dimension ZE[NX][NY].
   RO,TI      Angulo de rotacion, inclinacion en grados.
   S          =1.0 Grafica parte positiva, = -1.0 Parte negativa.
   pl         Funcion de conversion de coordenadas. (usual pltca)
   (H.V.McIntosh, 31.MAY.75)
   (Fco.Gil, 23.DIC.84)
   (Conv. a C,G. Cisneros, 15.JUL.88)
   (Angel Canto, 16.Mar.89)
*/
{
  double O[3][3];

   visnh();
   plteu(&O[0][0], RO, TI, 0.0);
   pviis(Z1, ZE, Z2, 1, NX, NX, 1, NY, NY, &O[0][0], S, pl);
}
