#include "vis.h"

void pvviv(double Z1, double ZE[], double Z2, int NX, int NY, 
	   double RO, double TI, double S, void (*pl)())

/*       pvviv.c
   [Inclined view]
   Vista inclinada.
   Esta funcion es equivalente a "pviiv", salvo que esta grafica
   los valores positivos y negativos reales. En el caso de "pviiv"
   despues de checar el signo, toma el valor absoluto de la funcion
   para graficar.

   (Z1,Z2)   Rango de los valores de ZE.
   ZE[]      Arreglo con los valores de la funcion.
   NX,NY     Dimension ZE[NX][NY].
   RO,TI     Angulo de rotacion, inclinacion en grados.
   S         =1.0 Grafica parte positiva, = -1.0 Parte negativa.
   pl        Funcion de conversion de coordenadas. (usual pltca)
   (Fco. Gil, 29.DIC.84)
   (Conv. a C, G. Cisneros, 15.JUL.88)
   (Angel Canto, 16.Mar.89)
*/
{
  double O[3][3];

  visnh();
  plteu(&O[0][0], RO, TI, 0.0);
  pvvis(Z1, ZE, Z2, 1, NX, NX, 1, NY, NY, &O[0][0], S, pl);
}
