#include "vis.h"
#include <math.h>

extern int NN0,M;

#define SIZE 200
#define UP   0

#define EP  1.0E-3
#define EP2 0.5E-4

/*
 (BOUNDS).
 (H.V.McIntosh, 10.MAY.75)
 (Fco. Gil, 23.DIC.83)
 (Conv. a C, G. Cisneros, 30.JUN.88)
 (Angel Canto, 16.MAR.89)
*/

void visbo(X1, T1, B1, X0, T0, B0, X, Y, P, N, I, pl)

double  X1[],T1[],B1[];  /*Arreglos auxiliares*/
double  X0[],T0[],B0[];  /*Horizontes*/
double  X[];     /* X[N] ARREGLO DE ARGUMENTOS.                         */
double  Y[];     /* Y[N] ARREGLO DE VALORES DE LA FUNCION.              */
int    P[];     /* P[N] ARREGLO DE BANDERAS DE VISIBILIDAD.             */
int      N;     /* LONGITUD DEL ARREGLO.                                */
int      I;     /* DIRECCION DE MOVIMIENTO DE PLUMA (1 = DELANTE).      */
		/* (-1 = ATRAS).                                        */
void (*pl)();    /* FUNCION DE MOVIMIENTO DE PLUMA.                     */
{
  int     j,j0,j1,jj,l,k,kk,vv;
  int     do_1,do_2;
  double  U[2];
  double  s,et,eb,z,z0,ex,wy,xi,yi,xx,yy,xd;
  double  to,bo,te,be,dt,db,vt,vb,f,tt,bb;

 if (N <= 1) return;

 j  = (I > 0) ?  0 : N-1;
 j1 = (I > 0) ? -1 : M;
 (*pl)((double)X[j], (double)Y[j], UP);

 if (NN0 > 1) {
  s = (double)(I);
 et = 1.0;
 eb = -1.0;
  l = 1;
  k = (I > 0) ? 0 : 1;
 j0 = (I > 0) ? 0 : NN0-1;
  z = X[j];
 z0 = X0[j0];

 if ( fabs(z-z0) > EP2)
    if (s*(z-z0) < 0.0)
 do {
	  j1 = visbd(I+j1, M-1, 0);
	  (*pl)((double)X[j], (double)Y[j], P[j]);
	  X1[j1] = X[j];
	  T1[j1] = Y[j];
	  B1[j1] = Y[j];
	  j += I;
     } while (( fabs(X[j] - z0) > EP2) && (s*(X[j]-z0) < 0.0));
 else
 do { 
	j1 = visbd(I+j1, M-1, 0);
	X1[j1] = X0[j0];
	T1[j1] = T0[j0];
	B1[j1] = B0[j0];
	j0 += I;
     } while (( fabs(z-X0[j0]) > EP2) && (s*(z-X0[j0]) > 0.0));

while (( do_1 = (j >= 0 && j < N)) && (j0 >= 0 && j0 < NN0)) {
       do_2 = 1;
	z = X[j];
	z0 = X0[j0];

	if (I > 0) ex = (z < z0) ? z : z0;
	else       ex = (z > z0) ? z : z0;

	wy = visli(ex,  X,  Y, visbd(j + k,   N-1, 1) );
	to = visli(ex, X0, T0, visbd(j0 +k, NN0-1, 1) );
	bo = visli(ex, X0, B0, visbd(j0 +k, NN0-1, 1) );

	if ( fabs(ex-z0) <= (EP2)) j0 += I;
	if ( fabs(ex-z ) <= (EP2)) j  += I;
	te = (wy > to) ? wy : to;
	be = (wy < bo) ? wy : bo;
	dt = wy - to;
	db = wy - bo;
	vt = et + dt;
	vb = eb + db;
	if (!l) {
	 xd = ex - xx;
	 jj = -1;
	if( fsgn(dt) != fsgn(et)) {
	       vt = dt-et;
	  U[++jj] = xx-et*xd/vt;
	}
	if( fsgn(db) != fsgn(eb)) {
	  vb = db-eb;
	   U[++jj] = xx-eb*xd/vb;
	}
	if(xd == 0.0) xd = EP2;
	for (kk=0 ; kk <= jj ; kk++) {
	  if((kk == 0) && (jj == 0)) xi = U[0];
	  if((kk == 0) && (jj == 1))
	   if (I > 0)   xi = (U[0] < U[1]) ? U[0] : U[1];
	   else         xi = (U[0] > U[1]) ? U[0] : U[1];
	  if(kk == 1)
	    if (I > 0)  xi = (U[0] > U[1]) ? U[0] : U[1];
	    else        xi = (U[0] < U[1]) ? U[0] : U[1];

	   f = (xi-xx)/xd;
	  yi = yy+f*(wy-yy);
	  (*pl)(xi, yi, ((kk == 0) && vv));
	  if(( fabs(xx-xi) <= EP2) || ( fabs(xi-ex) <= EP2))
	   continue;
	  if((kk == 1) && ( fabs(U[0]-U[1]) <= EP2))
	   continue;
		j1 = visbd(I+j1, M-1, 0);
		X1[j1] = xi;
		T1[j1] = tt+f*(to-tt);
		B1[j1] = bb+f*(bo-bb);
	  }

	if((j1 > 0) && (j1 < M-1))
	if(vissl(ex, te, X1, T1, j1+k))
	if(vissl(ex, be, X1, B1, j1+k))
	do_2 = 0;
    }

       if (do_2) j1 = visbd(I+j1, M-1, 0);

	X1[j1] = ex;
	T1[j1] = te;
	B1[j1] = be;
	vv = ((vt > EP) || (-vb > EP)) && P[j];
	(*pl)(ex, wy, vv);
	l = 0;
	et = dt;
	eb = db;
	xx = ex;
	yy = wy;
	tt = to;
	bb = bo;
    }

   if (!do_1)
     while ((j0 >= 0) && (j0 < NN0)) {
	j1 = visbd(I+j1, M-1, 0);
	X1[j1] = X0[j0];
	T1[j1] = T0[j0];
	B1[j1] = B0[j0];
	j0 += I;
     }

    if (do_1)  (*pl)(ex, wy, UP);
  }
     if(do_1)
     while((j >= 0) && (j < N)) {
	(*pl)((double)X[j], (double)Y[j], P[j]);
	j1 = visbd(I+j1, M-1, 0);
	X1[j1] = X[j];
	T1[j1] = Y[j];
	B1[j1] = Y[j];
	j += I;
	}
      if(I > 0) {
	NN0 = j1+1;
	j1 = 0;
      } else {
       NN0 = M - j1;
       }
	for (j0=0 ; j0 < NN0 ; j0++,j1++) {
	  X0[j0] = X1[j1];
	  T0[j0] = T1[j1];
	  B0[j0] = B1[j1];
	}
}
