#include "vis.h"

extern int NN0,M;

#define SIZE 150

static double X1[SIZE],T1[SIZE],B1[SIZE];

static int P[SIZE] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		      1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		      1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		      1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		      1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		      1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		      1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		      1,1,1,1,1,1,1,1,1,1};

void vishh(double X0[], double T0[], double B0[], int *L0, double X[],
	   double Y[], int N, int I, void (*pl)())

/*       vishh.c
   [Half horizon]
   Horizonte medio.
   Esta funcion es equivalente a "visho" salvo que eta
   permite obtener los arreglos del horizonte superior.

   X0[]   Arreglo de argumentos de horizonte.
   T0[]   Arreglo de valores superiores del horizonte.
   B0[]   Arreglo de valores inferiores del horizonte.
   *L0    Longitud de arreglos.
   X[]    Arreglo de argumentos.
   Y[]    Arreglo de valores de la funcion.
   N      Longitud de arreglos X, Y.
   I      Direccion de la pluma.
   pl     Funcion de conversion de coordenadas.
   (H.V.McIntosh, 10.MAY.75)
   (Fco. Gil, 16.ENE.85)
   (Conv. a C, G. Cisneros, 30.JUN.88)
   (Angel Canto, 16 Mar.89)
*/
{
   NN0 = *L0;
   M = SIZE;
   visbo(X1, T1, B1, X0, T0, B0, X, Y, P, N, I, pl);
   *L0 = NN0;
}
